/* Process model C form file: megaco_mgc_node.pr.c */
/* Portions of this file copyright 1986-2009 by OPNET Technologies, Inc. */


/*
 =========================== NOTE ==========================
 This file is automatically generated from megaco_mgc_node.pr.m
 during a process model compilation.

 Do NOT manually edit this file.
 Manual edits will be lost during the next compilation.
 =========================== NOTE ==========================
*/



/* This variable carries the header into the object file */
const char megaco_mgc_node_pr_c [] = "MIL_3_Tfile_Hdr_ 160A 30A op_runsim_dev 7 4CE1C98C 4CE1C98C 1 olive kurthaha 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 277a 1                                                                                                                                                                                                                                                                                                                                                                                                     ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#include <ip_addr_v4.h>
#include <ip_rte_v4.h>
#include <ip_with_rip_v3.h>
#include <nato.h>
#include <udp_api.h>
#include <oms_pr.h>
#include <rip_notif_log_support.h>
#include <ip_cmn_rte_table.h>
#include <oms_tan.h>
#include <stdlib.h>
#include <ip_rte_support.h>


/* --------------------- DEFINITION OF CONSTANTS -------------------------------- */




#define STAT_MAX_SIZE   128
#define MAX_MSG_SIZE    1024
#define MG1_IP_ADDRESS  "172.16.0.2"
#define MG2_IP_ADDRESS  "172.16.0.3"



/* To identify different MEGACO messages */

#define MEGACO_MSG_SERVICECHANGE    1
#define MEGACO_MSG_NOTIFY           2
#define MEGACO_MSG_MODIFY           3

#define MEGACO_MSG_ADD              4
#define MEGACO_MSG_SUBTRACT         5

#define MEGACO_MSG_MOVE             6
#define MEGACO_MSG_AUDITVALUE       7
#define MEGACO_MSG_AUDITCAPABILITY  8


/* ------------------- END OF DEFINITION OF CONSTANTS ---------------------------- */



#define MGC     0
#define MG1     1
#define MG2     2
	


/* --------------------- DEFINITION OF STRUCTURES -------------------------------- */




/* Structure for MEGACO message parameters */
typedef struct
{
   int  message_type;
   int  mg_ip_address_valid;
   char mg_ip_address[32];
   int  mg_udp_port_valid;
   char mg_udp_port[16];
   int  audio_ip_address_valid;
   char audio_ip_address[32];
   int  audio_udp_port_valid;
   char audio_udp_port[16];
   int  transaction_id_valid;
   char transaction_id[32];
   int  context_id_valid;
   char context_id[32];
   int  termination_id1_valid;
   char termination_id1[32];
   int  termination_id2_valid;
   char termination_id2[32];
   int  termination_id3_valid;
   char termination_id3[32];
   int  request_id_valid;
   char request_id[32];
   int  codec_valid;
   char codec[32];
   int  detection_time_valid;
   char detection_time[32];
   int  detection_event_valid;
   char detection_event[32];
   int  dest_ip_address_valid;
   char dest_ip_address[32];
   int  rtp_ps_valid;
   char rtp_ps[32];
   int  rtp_pr_valid;
   char rtp_pr[32];
   int  rtp_pl_valid;
   char rtp_pl[32];
   int  rtp_jit_valid;
   char rtp_jit[32];
   int  rtp_delay_valid;
   char rtp_delay[32];

} STRUCT_MEGACO_MSG_PARAM;

/* Structure for MEGACO ServiceChange Reply parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char mg_udp_port[16];

} STRUCT_MEGACO_SERVICECHANGE_PARAM;

/* Structure of MEGACO Notify Reply parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   int  num_command;
   char termination_id1[32];
   char termination_id2[32];

} STRUCT_MEGACO_NOTIFY_PARAM;

/* Structure of MEGACO Subtract Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   int  num_command;
   char termination_id1[32];
   char termination_id2[32];

} STRUCT_MEGACO_SUBTRACT_PARAM;

/* Structure of MEGACO Modify Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   int  event_exist;
   char event_context_id[32];
   char event_termination_id[32];
   char event_request_id[32];
   char event[32];
   int  signal_exist;
   char signal_context_id[32];
   char signal_termination_id[32];
   char signal[32];
   int  rtp_exist;
   char rtp_context_id[32];
   char rtp_termination_id[32];
   int  rtp_localcontrol_exist;
   char rtp_localcontrol_mode[32];
   int  rtp_remote_exist;
   char rtp_remote_address[32];
   char rtp_remote_port[32];
   char rtp_remote_codec[32];

} STRUCT_MEGACO_MODIFY_PARAM;

/* Structure of MEGACO Move Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   int  signal_exist;
   char signal_termination_id[32];
   char signal[32];
   int  rtp_exist;
   char rtp_termination_id[32];
   int  rtp_localcontrol_exist;
   char rtp_localcontrol_mode[32];
   int  rtp_remote_exist;
   char rtp_remote_address[32];
   char rtp_remote_port[32];
   char rtp_remote_codec[32];

} STRUCT_MEGACO_MOVE_PARAM;

/* Structure of MEGACO Add Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   int  signal_exist;
   char signal_termination_id[32];
   char signal[32];
   int  rtp_exist;
   char rtp_termination_id[32];
   int  rtp_localcontrol_exist;
   char rtp_localcontrol_mode[32];
   int  rtp_local1_exist;
   int  rtp_local2_exist;
   int  rtp_remote_exist;
   char rtp_remote_address[32];
   char rtp_remote_port[32];
   char rtp_remote_codec[32];

} STRUCT_MEGACO_ADD_PARAM;

/* Structure of MEGACO AuditValue Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   char termination_id1[32];

} STRUCT_MEGACO_AUDITVALUE_PARAM;

/* Structure of MEGACO AuditCapability Request parameters */
typedef struct
{
   char mgc_ip_address[32];
   char mgc_udp_port[16];
   char transaction_id[32];
   char context_id[32];
   char termination_id1[32];

} STRUCT_MEGACO_AUDITCAPABILITY_PARAM;

/* Structure for MEGACO messages to be embedded in packets*/


typedef struct 

{


   char *msg;


	
} STRUCT_MEGACO_MSG;


	

/* Structure for TerminationID "ui" */
typedef struct

{

   char event[32];
   int  status;
	
} TerminationUI;


	
/* Structure for TerminationID "at/hf" */

typedef struct

{

   char signal[32]; 
   int  status;
	
} TerminationAT;


	
/* Structure for TerminationID "tr" */

typedef struct

{

   char ip_string[32];
   char udp_string[16];
   char codec[32];
   char context_id[32];
   int  waiting_party;
   int  status;
	
} TerminationRTP;



/* Structure for MG */


typedef struct

{

   char            ip_string[32];

   char            udp_string[16];

   TerminationUI   ui;

   TerminationAT   at;
   TerminationRTP  rtp;
   TerminationRTP  rtp1;

   TerminationRTP  rtp2;
   int             talking_party;
   
   STRUCT_MEGACO_MSG *ptr_megaco_req_msg;
   STRUCT_MEGACO_MSG *ptr_megaco_reply_msg;
	
} STRUCT_MEGACO_MG;


/* Structure for the message queue */

typedef struct
{
   int    transaction_id;
   char   megaco_msg[MAX_MSG_SIZE];
   char   dest_ip_address[32];
   int    sent;
   int    num_wait;
   STRUCT_MEGACO_MSG *ptr_msg_struct;
   
} STRUCT_MSG_QUEUE_BLK;

/* ------------------ END OF DEFINITION OF STRUCTURES ---------------------------- */




/* Constants for stream identification */
#define XMT_OUT_STRM    0

#define MSG_ARVL (op_intrpt_type() == OPC_INTRPT_STRM)
#define SEND_CHECK (op_intrpt_type() == OPC_INTRPT_REGULAR)

int VERBOSE;

/* End of Header Block */

#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	char	                   		mgc_ip_string[32]                               ;
	char	                   		mgc_udp_string[16]                              ;
	int	                    		mgc_transaction_id                              ;
	int	                    		mgc_request_id                                  ;
	int	                    		mgc_context_id                                  ;
	int	                    		msg_no                                          ;
	STRUCT_MEGACO_MSG_PARAM *			ptr_megaco_msg_param                            ;
	char	                   		line_feed[2]                                    ;
	List *	                 		ptr_MG_list                                     ;
	List *	                 		ptr_outstanding_message_list                    ;
	} megaco_mgc_node_state;

#define mgc_ip_string           		op_sv_ptr->mgc_ip_string
#define mgc_udp_string          		op_sv_ptr->mgc_udp_string
#define mgc_transaction_id      		op_sv_ptr->mgc_transaction_id
#define mgc_request_id          		op_sv_ptr->mgc_request_id
#define mgc_context_id          		op_sv_ptr->mgc_context_id
#define msg_no                  		op_sv_ptr->msg_no
#define ptr_megaco_msg_param    		op_sv_ptr->ptr_megaco_msg_param
#define line_feed               		op_sv_ptr->line_feed
#define ptr_MG_list             		op_sv_ptr->ptr_MG_list
#define ptr_outstanding_message_list		op_sv_ptr->ptr_outstanding_message_list

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#define FIN_PREAMBLE_DEC	megaco_mgc_node_state *op_sv_ptr;
#define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((megaco_mgc_node_state *)(OP_SIM_CONTEXT_PTR->_op_mod_state_ptr));


/* Function Block */

#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ + 2};
#endif

/* --------------------------------------------------- 
 *  To get the command type 
 * --------------------------------------------------*/
int find_command_verb(STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   FIN(find_command_verb(ptr_megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into find_command_verb().\n");
   }
   
   if (strstr(ptr_megaco_msg->msg, "ServiceChange") != NULL) {

	  if (VERBOSE) {
         printf ("MGC: Find ServiceChange command.\n");
	  }
      FRET(MEGACO_MSG_SERVICECHANGE);
		
   } else if (strstr(ptr_megaco_msg->msg, "Notify") != NULL) {

      if (VERBOSE) {
         printf ("MGC: Find Notify command.\n");
	  }
	  FRET(MEGACO_MSG_NOTIFY);
		
   } else if (strstr(ptr_megaco_msg->msg, "Modify") != NULL) {

	  if (VERBOSE) {
         printf ("MGC: Find Modify command.\n");
	  }
	  FRET(MEGACO_MSG_MODIFY);
		
   } else if (strstr(ptr_megaco_msg->msg, "Add") != NULL) {
      
	  if (VERBOSE) {
         printf ("MGC: Find Add command.\n");
	  }
	  FRET(MEGACO_MSG_ADD);
		
   } else if (strstr(ptr_megaco_msg->msg, "Subtract") != NULL) {
   
	  if (VERBOSE) {
         printf ("MGC: Find Subtract command.\n");
	  }
      FRET(MEGACO_MSG_SUBTRACT);
   
   } else if (strstr(ptr_megaco_msg->msg, "Move") != NULL) {
	 
	  if (VERBOSE) {
         printf ("MGC: Find Move command.\n");
	  }
	  FRET(MEGACO_MSG_MOVE);
		
   } else if (strstr(ptr_megaco_msg->msg, "AuditValue") != NULL) {
	
	  if (VERBOSE) {
         printf ("MGC: Find AuditValue command.\n");
	  }
	  FRET(MEGACO_MSG_AUDITVALUE);
		
   } else if (strstr(ptr_megaco_msg->msg, "AuditCapabilities") != NULL) {
	
	  if (VERBOSE) {
         printf ("MGC: Find AuditCapabilities command.\n");
	  }
	  FRET(MEGACO_MSG_AUDITCAPABILITY);
   }
     
   FRET(-1);
}

/* ---------------------------------------------- 
 *  To get the parameters of ServiceChange
 * ---------------------------------------------*/
Boolean get_servicechange_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_servicechange_parameters(parameters,ptr_megaco_msg));   

   if (VERBOSE) {
      printf("MGC: Into get_servicechange_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));
   
   /* Set the message type */
   parameters->message_type = MEGACO_MSG_SERVICECHANGE;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from ServiceChange - %s\n", parameters->mg_ip_address);
   }

   /* Get the string of the value of ServiceChangeAddress. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "ServiceChangeAddress=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 21;
   strncpy(parameters->mg_udp_port, ptr_char_start + 21, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from ServiceChange - %s\n", parameters->mg_udp_port);
   }
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Transaction =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 15;
   strncpy(parameters->transaction_id, ptr_char_start + 14, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from ServiceChange - %s\n", parameters->transaction_id);
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_servicechange_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of Notify
 * ---------------------------------------------*/
Boolean get_notify_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_notify_parameters(parameters, ptr_megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into get_notify_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));
   
   /* Set the message type */
   parameters->message_type = MEGACO_MSG_NOTIFY;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from Notify - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from Notify - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Transaction =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 15;
   strncpy(parameters->transaction_id, ptr_char_start + 14, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from Notify - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from Notify - %s\n", parameters->context_id);
   }
   
   /* Get the string of termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Notify =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 10;
   strncpy(parameters->termination_id1, ptr_char_start + 9, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: Termination ID from Notify - %s\n", parameters->termination_id1);
   }

   /* Get the string of request ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "ObservedEvents =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 18;
   strncpy(parameters->request_id, ptr_char_start + 17, str_length);
   (parameters->request_id)[str_length] = '\0';
   parameters->request_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Request ID from Notify - %s\n", parameters->request_id);
   }
   
   /* Get the string of detection time. */
   ptr_char_start = ptr_char_end + 2;
   ptr_char_end = strchr(ptr_char_start, ':');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start;
   strncpy(parameters->detection_time, ptr_char_start, str_length);
   (parameters->detection_time)[str_length] = '\0';
   parameters->detection_time_valid = 1;
   if (VERBOSE) {
      printf("MGC: Detection Time from Notify - %s\n", parameters->detection_time);
   }
   
   /* Get the string of detected event. */
   ptr_char_start = ptr_char_end + 1;
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start;
   strncpy(parameters->detection_event, ptr_char_start, str_length);
   (parameters->detection_event)[str_length] = '\0';
   parameters->detection_event_valid = 1;
   if (VERBOSE) {
      printf("MGC: Detection Event from Notify - %s\n", parameters->detection_event);
   }
   
   /* Get the string for destination IP address */
   if (!strcmp(parameters->detection_event, "dd/ce")) {
   
      ptr_char_start = strstr(ptr_megaco_msg->msg, "ds=");
      if (ptr_char_start == OPC_NIL)
      {
         FRET(OPC_FALSE);
      }
      ptr_char_end = strchr(ptr_char_start, '}');
      if (ptr_char_end == OPC_NIL)
      {
         FRET(OPC_FALSE);
      }
      str_length = ptr_char_end - ptr_char_start - 5;
      strncpy(parameters->dest_ip_address, ptr_char_start + 4, str_length);
      (parameters->dest_ip_address)[str_length] = '\0';
      parameters->dest_ip_address_valid = 1;
      if (VERBOSE) {
         printf("MGC: Dial IP Address from Notify - %s\n", parameters->dest_ip_address);
      }
   }
	
   if (VERBOSE) {
      printf("MGC: Out get_notify_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of Modify
 * ---------------------------------------------*/
Boolean get_modify_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   FIN(get_modify_parameters(parameters, ptr_megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into get_modify_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));
   
   /* Set the message type */
   parameters->message_type = MEGACO_MSG_MODIFY;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from Modify - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from Modify - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from Modify - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   ptr_char_start = strstr(ptr_char_end + 1, "Context =");
   if (ptr_char_start != OPC_NIL)
   {
      ptr_char_end = strchr(ptr_char_start, '{');
	  if (ptr_char_end == OPC_NIL)
	  {
	     FRET(OPC_FALSE);
	  }
	  str_length = ptr_char_end - ptr_char_start - 11;
	  strncpy(parameters->context_id, ptr_char_start + 10, str_length);
	  (parameters->context_id)[str_length] = '\0';
   }
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from Modify - %s\n", parameters->context_id);
   }

   /* Get the first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Modify =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   if (*(ptr_char_end - 1) == ',')
   {
      ptr_char_end -= 1;
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->termination_id1, ptr_char_start + 9, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: First Termination ID from Modify - %s\n", parameters->termination_id1);
   }
   
   /* Get the second termination ID if it exists. */
   ptr_char_start = strstr(ptr_char_end + 1, "Modify =");
   if (ptr_char_start != OPC_NIL)
   {
      ptr_char_end = strchr(ptr_char_start, '\n');
      if (ptr_char_end == OPC_NIL)
      {
         FRET(OPC_FALSE);
      }
      if (*(ptr_char_end - 1) == ',')
      {
         ptr_char_end -= 1;
      }
      str_length = ptr_char_end - ptr_char_start - 9;
      strncpy(parameters->termination_id2, ptr_char_start + 9, str_length);
      (parameters->termination_id2)[str_length] = '\0';
      parameters->termination_id2_valid = 1;
      if (VERBOSE) {
         printf("MGC: Second Termination ID from Modify - %s\n", parameters->termination_id2);
      }
	   
	  /* Get the third termination ID if it exists. */
      ptr_char_start = strstr(ptr_char_end + 1, "Modify =");
      if (ptr_char_start != OPC_NIL)
      {
         ptr_char_end = strchr(ptr_char_start, '\n');
         if (ptr_char_end == OPC_NIL)
         {
            FRET(OPC_FALSE);
         }
         if (*(ptr_char_end - 1) == ',')
         {
            ptr_char_end -= 1;
         }
         str_length = ptr_char_end - ptr_char_start - 9;
         strncpy(parameters->termination_id3, ptr_char_start + 9, str_length);
         (parameters->termination_id3)[str_length] = '\0';
         parameters->termination_id3_valid = 1;
         if (VERBOSE) {
            printf("MGC: Third Termination ID from Modify - %s\n", parameters->termination_id3);
         }
	  }
   }
	
   
   if (VERBOSE) {
      printf("MGC: Out get_modify_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of Move
 * ---------------------------------------------*/
Boolean get_move_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   FIN(get_move_parameters(parameters, ptr_megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into get_move_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));
   
   /* Set the message type */
   parameters->message_type = MEGACO_MSG_MOVE;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from Move - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from Move - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from Move - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from Move - %s\n", parameters->context_id);
   }

   /* Get the first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Move =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   if (*(ptr_char_end - 1) == ',')
   {
      ptr_char_end -= 1;
   }
   str_length = ptr_char_end - ptr_char_start - 7;
   strncpy(parameters->termination_id1, ptr_char_start + 7, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: First Termination ID from Move - %s\n", parameters->termination_id1);
   }
   
   /* Get the second termination ID if it exists. */
   ptr_char_start = strstr(ptr_char_end + 1, "Move =");
   if (ptr_char_start != OPC_NIL)
   {
      ptr_char_end = strchr(ptr_char_start, '\n');
      if (ptr_char_end == OPC_NIL)
      {
         FRET(OPC_FALSE);
      }
      if (*(ptr_char_end - 1) == ',')
      {
         ptr_char_end -= 1;
      }
      str_length = ptr_char_end - ptr_char_start - 7;
      strncpy(parameters->termination_id2, ptr_char_start + 7, str_length);
      (parameters->termination_id2)[str_length] = '\0';
      parameters->termination_id2_valid = 1;
      if (VERBOSE) {
         printf("MGC: Second Termination ID from Move - %s\n", parameters->termination_id2);
      }
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_move_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}   
   
/* ---------------------------------------------- 
 *  To get the parameters of Add
 * ---------------------------------------------*/
Boolean get_add_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_add_parameters(parameters,ptr_megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into get_add_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));

   /* Set the message type */
   parameters->message_type = MEGACO_MSG_ADD;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from Add - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from Add - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from Add - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from Add - %s\n", parameters->context_id);
   }
   
   /* Get the string of first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Add =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 6;
   strncpy(parameters->termination_id1, ptr_char_start + 6, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: First Termination ID from Add - %s\n", parameters->termination_id1);
   }
   
   /* Get the string of second termination ID. */
   ptr_char_start = strstr(ptr_char_end + 1, "Add =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 7;
   strncpy(parameters->termination_id2, ptr_char_start + 6, str_length);
   (parameters->termination_id2)[str_length] = '\0';
   parameters->termination_id2_valid = 1;
   if (VERBOSE) {
      printf("MGC: Second Termination ID from Add - %s\n", parameters->termination_id2);
   }
      
   /* Get the string of IP address in Local Descriptor. */
   ptr_char_start = strstr(ptr_char_start, "IP4 ");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 4;
   strncpy(parameters->audio_ip_address, ptr_char_start + 4, str_length);
   (parameters->audio_ip_address)[str_length] = '\0';
   parameters->audio_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP IP Address from Add - %s\n", parameters->audio_ip_address);
   }
   
   /* Get the string of UDP port in Local Descriptor. */
   ptr_char_start = strstr(ptr_char_start, "audio ");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start + 6, ' ');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 6;
   strncpy(parameters->audio_udp_port, ptr_char_start + 6, str_length);
   (parameters->audio_udp_port)[str_length] = '\0';
   parameters->audio_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP UDP Port from Add - %s\n", parameters->audio_udp_port);
   }
   
   /* Get the string of codec value in Local Descriptor. */
   ptr_char_start = strstr(ptr_char_start, "RTP/AVP ");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 8;
   strncpy(parameters->codec, ptr_char_start + 8, str_length);
   (parameters->codec)[str_length] = '\0';
   parameters->codec_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP Codec from Add - %s\n", parameters->codec);
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_add_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of Subtract
 * ---------------------------------------------*/
Boolean get_subtract_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_subtract_parameters(parameters,ptr_megaco_msg));   

   if (VERBOSE) {
      printf("MGC: Into get_substract_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));

   /* Set the message type */
   parameters->message_type = MEGACO_MSG_SUBTRACT;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from Subtract - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from Subtract - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from Subtract - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from Subtract - %s\n", parameters->context_id);
   }
   
   /* Get the string of first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Subtract =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11;
   strncpy(parameters->termination_id1, ptr_char_start + 11, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: First Termination ID from Subtract - %s\n", parameters->termination_id1);
   }
   
   /* Get the string of second termination ID. */
   ptr_char_start = strstr(ptr_char_end + 1, "Subtract =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 12;
   strncpy(parameters->termination_id2, ptr_char_start + 11, str_length);
   (parameters->termination_id2)[str_length] = '\0';
   parameters->termination_id2_valid = 1;
   if (VERBOSE) {
      printf("MGC: Second Termination ID from Subtract - %s\n", parameters->termination_id2);
   }
   
   /* Get the string of packets sent value. */
   ptr_char_start = strstr(ptr_char_start, "rtp/ps=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 7;
   strncpy(parameters->rtp_ps, ptr_char_start + 7, str_length);
   (parameters->rtp_ps)[str_length] = '\0';
   parameters->rtp_ps_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP/PS from Subtract - %s\n", parameters->rtp_ps);
   }
   
   
   /* Get the string of packets received value. */
   ptr_char_start = strstr(ptr_char_start, "rtp/pr=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 7;
   strncpy(parameters->rtp_pr, ptr_char_start + 7, str_length);
   (parameters->rtp_pr)[str_length] = '\0';
   parameters->rtp_pr_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP/PR from Subtract - %s\n", parameters->rtp_pr);
   }
   
   /* Get the string of packets loss value. */
   ptr_char_start = strstr(ptr_char_start, "rtp/pl=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 7;
   strncpy(parameters->rtp_pl, ptr_char_start + 7, str_length);
   (parameters->rtp_pl)[str_length] = '\0';
   parameters->rtp_pl_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP/PL from Subtract - %s\n", parameters->rtp_pl);
   }

   /* Get the string of jitter value. */
   ptr_char_start = strstr(ptr_char_start, "rtp/jit=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ',');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 8;
   strncpy(parameters->rtp_jit, ptr_char_start + 8, str_length);
   (parameters->rtp_jit)[str_length] = '\0';
   parameters->rtp_jit_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP/JIT from Subtract - %s\n", parameters->rtp_jit);
   }

   /* Get the string of delay value. */
   ptr_char_start = strstr(ptr_char_start, "rtp/delay=");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 10;
   strncpy(parameters->rtp_delay, ptr_char_start + 10, str_length);
   (parameters->rtp_delay)[str_length] = '\0';
   parameters->rtp_delay_valid = 1;
   if (VERBOSE) {
      printf("MGC: RTP/DELAY from Subtract - %s\n", parameters->rtp_delay);
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_subtract_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of AuditValue
 * ---------------------------------------------*/
Boolean get_auditvalue_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_auditvalue_parameters(parameters,ptr_megaco_msg));   

   if (VERBOSE) {
      printf("MGC: Into get_auditvalue_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));

   /* Set the message type */
   parameters->message_type = MEGACO_MSG_AUDITVALUE;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from AuditValue - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from AuditValue - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from AuditValue - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from AuditValue - %s\n", parameters->context_id);
   }
   
   /* Get the string of first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "AuditValue =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 14;
   strncpy(parameters->termination_id1, ptr_char_start + 13, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: Termination ID from AuditValue - %s\n", parameters->termination_id1);
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_auditvalue_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  To get the parameters of AuditCapability
 * ---------------------------------------------*/
Boolean get_auditcapability_parameters(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int  str_length;
   char *ptr_char_start;
   char *ptr_char_end;

   
   FIN(get_auditcapability_parameters(parameters,ptr_megaco_msg));   

   if (VERBOSE) {
      printf("MGC: Into get_auditcapability_parameters().\n");
   }
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------|\n");
   printf("| [%d] MGC received the following message:                                    |\n", msg_no++);
   printf("|-----------------------------------------------------------------------------|\n");
   printf("%s", ptr_megaco_msg->msg);
   printf("|-----------------------------------------------------------------------------|\n\n");

   /* Initialize the structure of the Megaco parameters */
   memset(parameters, 0, sizeof(STRUCT_MEGACO_MSG_PARAM));

   /* Set the message type */
   parameters->message_type = MEGACO_MSG_AUDITCAPABILITY;
   
   /* Get the string of IP address. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, '[');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, ']');
   if ( ptr_char_end == OPC_NIL )
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_ip_address, ptr_char_start + 1, str_length);
   (parameters->mg_ip_address)[str_length] = '\0';
   parameters->mg_ip_address_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG IP Address from AuditCapability - %s\n", parameters->mg_ip_address);
   }   
   
   /* Get the string of UDP port. */
   ptr_char_start = strchr(ptr_megaco_msg->msg, ':');   
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '\n');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 1;
   strncpy(parameters->mg_udp_port, ptr_char_start + 1, str_length);
   (parameters->mg_udp_port)[str_length] = '\0';
   parameters->mg_udp_port_valid = 1;
   if (VERBOSE) {
      printf("MGC: MG UDP Port from AuditCapability - %s\n", parameters->mg_udp_port);
   }   
   
   /* Get the string of transaction ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Reply =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 9;
   strncpy(parameters->transaction_id, ptr_char_start + 8, str_length);
   (parameters->transaction_id)[str_length] = '\0';
   parameters->transaction_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Transaction ID from AuditCapability - %s\n", parameters->transaction_id);
   }
   
   /* Get the string of context ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "Context =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 11; 
   strncpy(parameters->context_id, ptr_char_start + 10, str_length);
   (parameters->context_id)[str_length] = '\0';
   parameters->context_id_valid = 1;
   if (VERBOSE) {
      printf("MGC: Context ID from AuditCapability - %s\n", parameters->context_id);
   }
   
   /* Get the string of first termination ID. */
   ptr_char_start = strstr(ptr_megaco_msg->msg, "AuditCapabilities =");
   if (ptr_char_start == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   ptr_char_end = strchr(ptr_char_start, '{');
   if (ptr_char_end == OPC_NIL)
   {
      FRET(OPC_FALSE);
   }
   str_length = ptr_char_end - ptr_char_start - 19;
   strncpy(parameters->termination_id1, ptr_char_start + 18, str_length);
   (parameters->termination_id1)[str_length] = '\0';
   parameters->termination_id1_valid = 1;
   if (VERBOSE) {
      printf("MGC: Termination ID from AuditCapability - %s\n", parameters->termination_id1);
   }
   
   if (VERBOSE) {
      printf("MGC: Out get_auditcapability_parameters().\n");
   }
   
   FRET(OPC_TRUE);
}
						 
/* -------------------------------------------------- 
 *  To get the command type and related parameters 
 * -------------------------------------------------*/
int parse_megaco_msg(STRUCT_MEGACO_MSG_PARAM *parameters, STRUCT_MEGACO_MSG *ptr_megaco_msg)
{
   int command_verb;

   
   FIN (parse_megaco_msg (parameters,ptr_megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into parse_megaco_msg().\n");
   }
   
   command_verb = find_command_verb(ptr_megaco_msg);
   
   switch (command_verb)
   {
   case MEGACO_MSG_SERVICECHANGE:

      if (get_servicechange_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
      break;

   case MEGACO_MSG_NOTIFY:

      if (get_notify_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
      break;

   case MEGACO_MSG_MODIFY:

      if (get_modify_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
      break;

   case MEGACO_MSG_ADD:

	  if (get_add_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
      break;

   case MEGACO_MSG_SUBTRACT:

	  if (get_subtract_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
      break;
		 
   case MEGACO_MSG_MOVE:
	  
	  if (get_move_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
	  break;
		 
   case MEGACO_MSG_AUDITVALUE:
   
      if (get_auditvalue_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
	  break;
		 
   case MEGACO_MSG_AUDITCAPABILITY:
   
      if (get_auditcapability_parameters(parameters, ptr_megaco_msg) == OPC_FALSE)
	  {
	     command_verb = -1;
	  }
	  break;

   default:
	  
      op_sim_end("MGC ERROR: ", "Failed to evaluate the command!", OPC_NIL, OPC_NIL);
      break;
   }

   if (VERBOSE) {
      printf("MGC: Out parse_megaco_msg().\n");
   }
   
   FRET(command_verb); 
}

/* ----------------------------------------------
 *  Convert the IP Address String
 *  to 32-bit Integer
 * ---------------------------------------------*/
Boolean ip_string_2_ip_int(char *ip_string, int *ip_value)
{
   int    IP1_value;
   int    IP2_value;
   int    IP3_value;
   int    IP4_value;
   char   IP1[16];
   char   IP2[16];
   char   IP3[16];
   char   IP4[16];
   char   *start_char;
   char   *end_char;
   
   FIN(ip_string_2_ip_int(ip_string));
   
   if (VERBOSE) {
      printf("MGC: Into ip_string_2_ip_int().\n");
	  printf("MGC: Convert %s to Integer value.\n", ip_string);
   }

   /* Initialize the returned parameter */
   *ip_value = 0;
   
   memset(IP1, 0, 16);
   memset(IP2, 0, 16);
   memset(IP3, 0, 16);
   memset(IP4, 0, 16);
   
   start_char = ip_string;
   end_char = strchr(start_char, '.');
   if (end_char == OPC_NIL) {
      FRET(OPC_FALSE);
   }
   strncpy(IP1, start_char, (int)(end_char - start_char));
   
   start_char = end_char + 1;
   if (*start_char == '\0') {
      FRET(OPC_FALSE);
   }
   end_char = strchr(start_char, '.');
   if (end_char == OPC_NIL) {
      FRET(OPC_FALSE);
   }
   strncpy(IP2, start_char, (int)(end_char - start_char));
      
   start_char = end_char + 1;
   if (*start_char == '\0') {
      FRET(OPC_FALSE);
   }
   end_char = strchr(start_char, '.');
   if (end_char == OPC_NIL) {
      FRET(OPC_FALSE);
   }
   strncpy(IP3, start_char, (int)(end_char - start_char));
   
   start_char = end_char + 1;
   if (*start_char == '\0') {
      FRET(OPC_FALSE);
   }
   strcpy(IP4, start_char);   
   
   IP1_value = atoi(IP1);
   IP2_value = atoi(IP2);
   IP3_value = atoi(IP3);
   IP4_value = atoi(IP4);
   
   *ip_value = (IP1_value & 0xFF) << 24 | (IP2_value & 0xFF) << 16 | (IP3_value & 0xFF) << 8 | (IP4_value & 0xFF);
   
   if (VERBOSE) {
      printf("MGC: Out ip_string_2_ip_int().\n");
	  printf("MGC: %s -> 0x%x\n", ip_string, *ip_value);
   }
   
   FRET(OPC_TRUE);
}

/* ----------------------------------------------
 *  Send message to MG
 * ---------------------------------------------*/
void send_to_MG(char *megaco_msg, char *dest_ip_address, STRUCT_MEGACO_MSG *ptr_msg_struct)
{
   int    data_size_bits;
   int    dest_ip_value;
   Packet *megaco_pkt = NULL;
   Packet *ptr_megaco_pkt = NULL; 

   
   FIN(send_to_MG(megaco_msg, dest_ip_address, ptr_msg_struct));
   
   if (VERBOSE) {
      printf("MGC: Into send_to_MG().\n");
   }
   
   /* Convert IP String to IP Integer value */
   if(!ip_string_2_ip_int(dest_ip_address, &dest_ip_value)) {
      FOUT;
   }
   
   /* Creates the message content to be sent to MG */
   if (ptr_msg_struct->msg != OPC_NIL) {
      op_prg_mem_free(ptr_msg_struct->msg);
   }
   ptr_msg_struct->msg = (char *)op_prg_mem_alloc(sizeof(char) * MAX_MSG_SIZE);
   if (ptr_msg_struct->msg == OPC_NIL) {
   
      op_sim_end("MGC ERROR: ",
		         "Failed to allocate message buffer for data transmission!",
				 OPC_NIL,
				 OPC_NIL);
   }
   strcpy(ptr_msg_struct->msg, megaco_msg);
   
   /* Create the packet */
   data_size_bits = (strlen(ptr_msg_struct->msg) + 1) * 8;
   ptr_megaco_pkt = op_pk_create(data_size_bits);
   if (ptr_megaco_pkt == OPC_NIL) {
      FOUT;
   }
   megaco_pkt = op_pk_create_fmt("megaco_pkt_v0");
   if (megaco_pkt == OPC_NIL) {
      FOUT;
   }
   
   op_pk_fd_set(ptr_megaco_pkt,
	            0,
				OPC_FIELD_TYPE_STRUCT,
				ptr_msg_struct,
				data_size_bits,
				op_prg_mem_copy_create,
				op_prg_mem_free,
				sizeof(STRUCT_MEGACO_MSG));

   op_pk_nfd_set(megaco_pkt, "dest_address", dest_ip_value);
   op_pk_nfd_set(megaco_pkt, "data", ptr_megaco_pkt);
   
   if (VERBOSE) {
      printf("\n");
      printf("|-----------------------------------------------------------------------------\n");
      printf("| [%d] MGC is sending to MG (IP: %s).\n", msg_no, dest_ip_address);
      printf("|-----------------------------------------------------------------------------\n");
   }

   op_pk_send(megaco_pkt, XMT_OUT_STRM);
   
   /* Print out the message information */
   printf("\n");
   printf("|-----------------------------------------------------------------------------\n");
   printf("| [%d] MGC just sent MG (IP: %s) the following message:\n", msg_no++, dest_ip_address);
   printf("|-----------------------------------------------------------------------------\n");
   printf("%s", megaco_msg);
   printf("|-----------------------------------------------------------------------------\n\n");
   
   if (VERBOSE) {
      printf("MGC: Out send_to_MG().\n");
   }
   
   FOUT;
}

Boolean add_msg_to_queue(int    transaction_id,
	                     char   *msg,
	                     char   *ip_address,
	                     STRUCT_MEGACO_MSG *ptr_msg_struct)
/* ----------------------------------------------
 *  Add message to the message queue
 * ---------------------------------------------*/
{
   STRUCT_MSG_QUEUE_BLK  *queue_blk;
   
   FIN(add_msg_to_queue(transaction_id, msg, ip_address, ptr_msg_struct));
   
   if (VERBOSE) {
      printf("MGC: Into add_msg_to_queue().\n");
   }
   
   if (ptr_outstanding_message_list == OPC_NIL) {
   
      op_sim_end("MGC ERROR: ",
	             "Memory queue is invalid!",
                 OPC_NIL,
                 OPC_NIL);
   }
   
   queue_blk = (STRUCT_MSG_QUEUE_BLK *)op_prg_mem_alloc(sizeof(STRUCT_MSG_QUEUE_BLK));
   if (queue_blk == OPC_NIL) {

      op_sim_end("MGC ERROR: ",
		         "Failed to allocate memory for the message queue block!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Initialize the message queue block */
   memset(queue_blk, 0, sizeof(STRUCT_MSG_QUEUE_BLK));
   
   /* Set up the message block */
   queue_blk->transaction_id = transaction_id;
   strncpy(queue_blk->megaco_msg, msg, MAX_MSG_SIZE);
   strcpy(queue_blk->dest_ip_address, ip_address);
   queue_blk->ptr_msg_struct = ptr_msg_struct;
   
   /* Add the message blk to the end of the queue */
   op_prg_list_insert(ptr_outstanding_message_list, queue_blk, OPC_LISTPOS_TAIL);
   
   if (VERBOSE) {
      printf("MGC: Out add_msg_to_queue().\n");
   }
   
   FRET(OPC_TRUE);
}

Boolean remove_msg_from_queue(int transaction_id)
/* ----------------------------------------------
 *  Remove and free the message block from queue
 * ---------------------------------------------*/
{
   STRUCT_MSG_QUEUE_BLK  *queue_blk;
   
   FIN(remove_msg_to_queue(transaction_id));
   
   if (VERBOSE) {
      printf("MGC: Into remove_msg_from_queue().\n");
   }
   
   if (ptr_outstanding_message_list == OPC_NIL) {
   
      op_sim_end("MGC ERROR: ",
	             "Memory queue is invalid!",
                 OPC_NIL,
                 OPC_NIL);
   }
   
   /* Get the first block in the queue */
   if (op_prg_list_size(ptr_outstanding_message_list) > 0) {
   
      queue_blk = (STRUCT_MSG_QUEUE_BLK *) op_prg_list_access(ptr_outstanding_message_list, OPC_LISTPOS_HEAD);
      if (queue_blk == OPC_NIL) {

         if (VERBOSE) {
	        printf("MGC ERROR: No message block is in the queue.\n");
		    printf("MGC: Out remove_msg_from_queue().\n");
	     }
	  
	     FRET(OPC_FALSE);
      }
  
   } else {
   
      FRET(OPC_FALSE);
   }
   
   /* See if the first block has the same transaction id */
   if (queue_blk->transaction_id != transaction_id) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: The message block in the queue does not match with the reply transaction uid.\n");
		 printf("MGC: Out remove_msg_from_queue().\n");
	  }
	  
	  FRET(OPC_FALSE);
	  
   } else {
   
      /* Remove and free the first message block */
      queue_blk = (STRUCT_MSG_QUEUE_BLK *) op_prg_list_remove(ptr_outstanding_message_list, OPC_LISTPOS_HEAD);
	  if (queue_blk != OPC_NIL) {

		 op_prg_mem_free(queue_blk);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out remove_msg_from_queue().\n");
   }
   
   FRET(OPC_TRUE);
}

/* ---------------------------------------------- 
 *  Compose ServiceChange Reply
 * ---------------------------------------------*/
void compose_servicechange(STRUCT_MEGACO_SERVICECHANGE_PARAM *parameters,
	                       char *megaco_msg)
{
   FIN(compose_servicechange(parameters, megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into compose_servicechange().\n");
   }
   
   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Reply = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = - {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "ServiceChange = ROOT {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Services {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "ServiceChangeAddress=");
   strcat(megaco_msg, parameters->mg_udp_port);
   strcat(megaco_msg, ",");   
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Profile=IPPhone/1");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}" );
   strcat(megaco_msg, line_feed);
		  
   if (VERBOSE) {
      printf("MGC: Out compose_servicechange().\n");
	  printf("MGC: compose_servicechange() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose Notify Reply
 * ---------------------------------------------*/
void compose_notify(STRUCT_MEGACO_NOTIFY_PARAM *parameters,
	                   char *megaco_msg)
{
   FIN(compose_notify(parameters, megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into compose_notify().\n");
   }
   
   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Reply = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed );
   strcat(megaco_msg, "Notify = ");
   strcat(megaco_msg, parameters->termination_id1);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}}" );
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_notify().\n");
	  printf("MGC: compose_notify() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose Modify Request
 * ---------------------------------------------*/
void compose_modify(STRUCT_MEGACO_MODIFY_PARAM *parameters,
	                char *megaco_msg)
{
   Boolean bPreviousDone = OPC_FALSE;
   
   FIN(compose_modify(parameters, megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into compose_modify().\n");
   }
   
   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   
   if (parameters->event_exist != 0) {
   
      strcat(megaco_msg, "Context = ");
      strcat(megaco_msg, parameters->event_context_id);
      strcat(megaco_msg, " {");
      strcat(megaco_msg, line_feed);
      strcat(megaco_msg, "Modify = ");
	  strcat(megaco_msg, parameters->event_termination_id);
	  strcat(megaco_msg, " {");
      strcat(megaco_msg, line_feed);
      strcat(megaco_msg, "Events = ");
      strcat(megaco_msg, parameters->event_request_id);
      strcat(megaco_msg, " {");
      strcat(megaco_msg, parameters->event);
      strcat(megaco_msg, "}");
      strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "}");
	  
	  bPreviousDone = OPC_TRUE;
   }
   
   if (parameters->signal_exist != 0) {
	  
      if (bPreviousDone) {
	  
         if (!strcmp(parameters->event_context_id, parameters->signal_context_id)) {
            strcat(megaco_msg, ",");
            strcat(megaco_msg, line_feed);
         } else {
	        strcat(megaco_msg, "},");
            strcat(megaco_msg, line_feed);
            strcat(megaco_msg, "Context = ");
            strcat(megaco_msg, parameters->signal_context_id);
            strcat(megaco_msg, " {");
            strcat(megaco_msg, line_feed);
         }
				   
	  } else {
	  
         strcat(megaco_msg, "Context = ");
         strcat(megaco_msg, parameters->signal_context_id);
         strcat(megaco_msg, " {");
         strcat(megaco_msg, line_feed);
	  }
				
	  strcat(megaco_msg, "Modify = ");
	  strcat(megaco_msg, parameters->signal_termination_id);
	  strcat(megaco_msg, " {");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "Signal = {");
	  strcat(megaco_msg, parameters->signal);
	  strcat(megaco_msg, "}");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "}");
	  
	  bPreviousDone = OPC_TRUE;
   }

   if (parameters->rtp_exist != 0) {
   
      if (bPreviousDone) {
    
         if (!strcmp(parameters->signal_context_id, parameters->rtp_context_id)) {
            strcat(megaco_msg, ",");
	        strcat(megaco_msg, line_feed);
         } else {
	        strcat(megaco_msg, "},");
            strcat(megaco_msg, line_feed);
            strcat(megaco_msg, "Context = ");
            strcat(megaco_msg, parameters->rtp_context_id);
            strcat(megaco_msg, " {");
            strcat(megaco_msg, line_feed);
         }
				   
	  } else {
	  
         strcat(megaco_msg, "Context = ");
         strcat(megaco_msg, parameters->rtp_context_id);
         strcat(megaco_msg, " {");
         strcat(megaco_msg, line_feed);
	  }

	  strcat(megaco_msg, "Modify = ");
	  strcat(megaco_msg, parameters->rtp_termination_id);
	  strcat(megaco_msg, " {");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "Media {");
	  strcat(megaco_msg, line_feed);
	  
	  if (parameters->rtp_localcontrol_exist != 0) {
	  
	     strcat(megaco_msg, "LocalControl {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "Mode=");
		 strcat(megaco_msg, parameters->rtp_localcontrol_mode);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
		 
	  } else if (parameters->rtp_remote_exist != 0) {
	  
	     strcat(megaco_msg, "Remote {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "v=0");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "c=IN IP4 ");
		 strcat(megaco_msg, parameters->rtp_remote_address);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "m=audio ");
		 strcat(megaco_msg, parameters->rtp_remote_port);
		 strcat(megaco_msg, " RTP/AVP ");
		 strcat(megaco_msg, parameters->rtp_remote_codec);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
	  }		 
	  
	  strcat(megaco_msg, "}}");
   }
   
   strcat(megaco_msg, "}}");
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_modify().\n");
	  printf("MGC: compose_modify() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose Add Request
 * ---------------------------------------------*/
void compose_add(STRUCT_MEGACO_ADD_PARAM *parameters,
	             char *megaco_msg)
{
   Boolean  bPreviousDone = OPC_FALSE;
   
   FIN(compose_add(parameters, megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into compose_add().\n");
   }

   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   
   if (parameters->signal_exist != 0) {
   
      strcat(megaco_msg, "Add = ");
	  strcat(megaco_msg, parameters->signal_termination_id);
	  
	  if (strlen(parameters->signal) > 0) {
	    
	     strcat(megaco_msg, " {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "Signal {");
		 strcat(megaco_msg, parameters->signal);
		 strcat(megaco_msg, "}");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
	  }
	  
	  bPreviousDone = OPC_TRUE;
   }
   
   if (parameters->rtp_exist != 0) {
   
      if (bPreviousDone) {
	     strcat(megaco_msg, ",");
		 strcat(megaco_msg, line_feed);
	  }
	  
	  bPreviousDone = OPC_FALSE;
	  
	  strcat(megaco_msg, "Add = ");
	  strcat(megaco_msg, parameters->rtp_termination_id);
	  strcat(megaco_msg, " {");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "Media {");
	  strcat(megaco_msg, line_feed);
	  
	  if (parameters->rtp_localcontrol_exist != 0) {
	     
	     strcat(megaco_msg, "LocalControl {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "Mode=");
		 strcat(megaco_msg, parameters->rtp_localcontrol_mode);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
		 
		 bPreviousDone = OPC_TRUE;
	  }
	  
	  if (parameters->rtp_local1_exist != 0) {
	  
   	     if (bPreviousDone) {
		    strcat(megaco_msg, ",");
			strcat(megaco_msg, line_feed);
		 }
	
		 strcat(megaco_msg, "Local {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "v=0");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "c=IN IP4 $");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "m=audio $ RTP/AVP 0");
		 strcat(megaco_msg, line_feed);
		 
		 if (parameters->rtp_local2_exist != 0) {
		 
            strcat(megaco_msg, "v=0");
            strcat(megaco_msg, line_feed);
            strcat(megaco_msg, "c=IN IP4 $");
            strcat(megaco_msg, line_feed);
            strcat(megaco_msg, "m=audio $ RTP/AVP 8");
            strcat(megaco_msg, line_feed);
		 }
		 
		 strcat(megaco_msg, "}");
		 
		 bPreviousDone = OPC_TRUE;
	  }
			
	  if (parameters->rtp_remote_exist != 0) {
	  
   	     if (bPreviousDone) {
		    strcat(megaco_msg, ",");
			strcat(megaco_msg, line_feed);
		 }
	
		 strcat(megaco_msg, "Remote {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "v=0");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "c=IN IP4 ");
		 strcat(megaco_msg, parameters->rtp_remote_address);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "m=audio ");
		 strcat(megaco_msg, parameters->rtp_remote_port);
		 strcat(megaco_msg, " RTP/AVP ");
		 strcat(megaco_msg, parameters->rtp_remote_codec);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
	  }
	  
	  strcat(megaco_msg, "}}");
   }

   strcat(megaco_msg, "}}");
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_add().\n");
	  printf("MGC: compose_add() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose Move Request
 * ---------------------------------------------*/
void compose_move(STRUCT_MEGACO_MOVE_PARAM *parameters,
	              char *megaco_msg)
{
   Boolean  bPreviousDone = OPC_FALSE;
   
   FIN(compose_move(parameters, megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into compose_move().\n");
   }

   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   
   if (parameters->signal_exist != 0) {
   
      strcat(megaco_msg, "Move = ");
	  strcat(megaco_msg, parameters->signal_termination_id);
	  
      strcat(megaco_msg, " {");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "Signal {");
	  if (strlen(parameters->signal) > 0) {
         strcat(megaco_msg, parameters->signal);
	  }
	  strcat(megaco_msg, "}");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "}");
	  
	  bPreviousDone = OPC_TRUE;
   }

   if (parameters->rtp_exist != 0) {
   
      if (bPreviousDone) {
	     strcat(megaco_msg, ",");
		 strcat(megaco_msg, line_feed);
	  }

	  bPreviousDone = OPC_FALSE;
	  
	  strcat(megaco_msg, "Move = ");
	  strcat(megaco_msg, parameters->rtp_termination_id);
	  strcat(megaco_msg, " {");
	  strcat(megaco_msg, line_feed);
	  strcat(megaco_msg, "Media {");
	  strcat(megaco_msg, line_feed);
	  
	  if (parameters->rtp_localcontrol_exist != 0) {
	     
	     strcat(megaco_msg, "LocalControl {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "Mode=");
		 strcat(megaco_msg, parameters->rtp_localcontrol_mode);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
		 
		 bPreviousDone = OPC_TRUE;
	  }
	  
	  if (parameters->rtp_remote_exist != 0) {

   	     if (bPreviousDone) {
		    strcat(megaco_msg, ",");
			strcat(megaco_msg, line_feed);
		 }
	  
		 strcat(megaco_msg, "Remote {");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "v=0");
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "c=IN IP4 ");
		 strcat(megaco_msg, parameters->rtp_remote_address);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "m=audio ");
		 strcat(megaco_msg, parameters->rtp_remote_port);
		 strcat(megaco_msg, " RTP/AVP ");
		 strcat(megaco_msg, parameters->rtp_remote_codec);
		 strcat(megaco_msg, line_feed);
		 strcat(megaco_msg, "}");
	  }
	  
	  strcat(megaco_msg, "}}");

   }

   strcat(megaco_msg, "}}");
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_move().\n");
	  printf("MGC: compose_move() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose Subtract Request
 * ---------------------------------------------*/
void compose_subtract(STRUCT_MEGACO_SUBTRACT_PARAM *parameters,
	                  char *megaco_msg)
{
   FIN(compose_subtract(parameters, megaco_msg));
   
   if (VERBOSE) {
      printf("MGC: Into compose_subtract().\n");
   }

   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   
   if (parameters->num_command > 0) {
      strcat(megaco_msg, "Subtract = ");
	  strcat(megaco_msg, parameters->termination_id1);
	  
	  if (parameters->num_command > 1) {
	     strcat(megaco_msg, ",");
	  }
	  
      strcat(megaco_msg, line_feed);
   }
   if (parameters->num_command > 1) {
      strcat(megaco_msg, "Subtract = ");
	  strcat(megaco_msg, parameters->termination_id2);
      strcat(megaco_msg, line_feed);
   }

   strcat(megaco_msg, "}}" );
   strcat(megaco_msg, line_feed );
   
   if (VERBOSE) {
      printf("MGC: Out compose_subtract().\n");
	  printf("MGC: compose_subtract() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose AuditValue Request
 * ---------------------------------------------*/
void compose_auditvalue(STRUCT_MEGACO_AUDITVALUE_PARAM *parameters,
	                    char *megaco_msg)
{
   FIN(compose_auditvalue(parameters, megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into compose_auditvalue().\n");
   }
   
   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed );
   strcat(megaco_msg, "AuditValue = ");
   strcat(megaco_msg, parameters->termination_id1);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Audit{Media, Statistics}");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}}}" );
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_auditvalue().\n");
	  printf("MGC: compose_auditvalue() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Compose AuditCapability Request
 * ---------------------------------------------*/
void compose_auditcapability(STRUCT_MEGACO_AUDITCAPABILITY_PARAM *parameters,
	                         char *megaco_msg)
{
   FIN(compose_auditcapability(parameters, megaco_msg));

   if (VERBOSE) {
      printf("MGC: Into compose_auditcapability().\n");
   }
   
   strcpy(megaco_msg, "MEGACO/1 [");
   strcat(megaco_msg, parameters->mgc_ip_address);
   strcat(megaco_msg, "]:");
   strcat(megaco_msg, parameters->mgc_udp_port);
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Transaction = ");
   strcat(megaco_msg, parameters->transaction_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Context = ");
   strcat(megaco_msg, parameters->context_id);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed );
   strcat(megaco_msg, "AuditCapabilities = ");
   strcat(megaco_msg, parameters->termination_id1);
   strcat(megaco_msg, " {");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "Audit{Events, Signals}");
   strcat(megaco_msg, line_feed);
   strcat(megaco_msg, "}}}" );
   strcat(megaco_msg, line_feed);
   
   if (VERBOSE) {
      printf("MGC: Out compose_auditcapability().\n");
	  printf("MGC: compose_auditcapability() returns the following:\n");
	  printf("%s\n\n", megaco_msg);
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Process ServiceChange Request
 * ---------------------------------------------*/
void servicechange_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   Boolean          bMGExist;
   int              i, list_size;
   STRUCT_MEGACO_MG *new_MG_info;
   
   char             megaco_msg[MAX_MSG_SIZE];
   STRUCT_MEGACO_SERVICECHANGE_PARAM sc_param;
   STRUCT_MEGACO_MODIFY_PARAM modify_param;
   STRUCT_MEGACO_AUDITCAPABILITY_PARAM ac_param;
   
   FIN(servicechange_process(parameters));
 
   if (VERBOSE) {
      printf ("MGC: Into servicechange_process().\n");
   }
   
   /* Initialize the variables */
   memset(&sc_param, 0, sizeof(STRUCT_MEGACO_SERVICECHANGE_PARAM));
   memset(&ac_param, 0, sizeof(STRUCT_MEGACO_AUDITCAPABILITY_PARAM));
   memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
   
      
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->transaction_id_valid ||
	   !parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve ServiceChange parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }

   /* Check if the specified MG is already existed. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      new_MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(new_MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   /* Create the MG structure, because it does not exist. */ 
   if (!bMGExist) {
      new_MG_info = (STRUCT_MEGACO_MG *) op_prg_mem_alloc(sizeof(STRUCT_MEGACO_MG));
	  op_prg_list_insert(ptr_MG_list, new_MG_info, OPC_LISTPOS_TAIL);
	  
      /* Initialize the MG structure */
      memset(new_MG_info, 0, sizeof(STRUCT_MEGACO_MG));
   
      /* Set the general MG info */
      strcpy(new_MG_info->ip_string, parameters->mg_ip_address);
      strcpy(new_MG_info->udp_string, parameters->mg_udp_port);
   
      /* Set up the message structure */
      new_MG_info->ptr_megaco_req_msg = (STRUCT_MEGACO_MSG *) op_prg_mem_alloc(sizeof(STRUCT_MEGACO_MSG));
      if (new_MG_info->ptr_megaco_req_msg == OPC_NIL) {

         if (VERBOSE) {
	        printf("MGC ERROR: Failed to allocate memory for MG request structure (%s).\n", parameters->mg_ip_address);
         }
	     op_sim_end("MGC ERROR: ",
		            "Failed to allocate memory for the MG request structure!",
			        OPC_NIL,
                    OPC_NIL);
      }
      new_MG_info->ptr_megaco_reply_msg = (STRUCT_MEGACO_MSG *) op_prg_mem_alloc(sizeof(STRUCT_MEGACO_MSG));
      if (new_MG_info->ptr_megaco_reply_msg == OPC_NIL) {

         if (VERBOSE) {
	        printf("MGC ERROR: Failed to allocate memory for MG reply structure (%s).\n", parameters->mg_ip_address);
	     }
	     op_sim_end("MGC ERROR: ",
		            "Failed to allocate memory for the MG reply structure!",
                    OPC_NIL,
				    OPC_NIL);
      }
   }
   
   /* Check the existence of the MG structure */
   if (new_MG_info == OPC_NIL) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to allocate memory for MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to allocate memory for the MG structure!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Set the ServiceChange parameters */
   strcpy(sc_param.mgc_ip_address, mgc_ip_string);
   strcpy(sc_param.mgc_udp_port, mgc_udp_string);
   strcpy(sc_param.transaction_id, parameters->transaction_id);
   strcpy(sc_param.mg_udp_port, parameters->mg_udp_port);
   
   /* Send ServiceChange message to MG. */
   memset(megaco_msg, 0, MAX_MSG_SIZE);
   compose_servicechange(&sc_param, megaco_msg);
   send_to_MG(megaco_msg, parameters->mg_ip_address, new_MG_info->ptr_megaco_reply_msg);

   /* Create a new Transaction ID. */
   if (mgc_transaction_id == 999999) {
      mgc_transaction_id = 1;
   } else {
      mgc_transaction_id++;
   }
   
   /* Set the AuditCapability parameters */
   strcpy(ac_param.mgc_ip_address, mgc_ip_string);
   strcpy(ac_param.mgc_udp_port, mgc_udp_string);
   sprintf(ac_param.transaction_id, "%d", mgc_transaction_id);
   strcpy(ac_param.context_id, "-");
   strcpy(ac_param.termination_id1, "ui");
   
   /* Send AuditCapability message to MG. */
   memset(megaco_msg, 0, MAX_MSG_SIZE);
   compose_auditcapability(&ac_param, megaco_msg);
   add_msg_to_queue(mgc_transaction_id, 
	   			    megaco_msg,
					parameters->mg_ip_address,
					new_MG_info->ptr_megaco_req_msg);
   
   /* Create a new Transaction ID. */
   if (mgc_transaction_id == 999999) {
      mgc_transaction_id = 1;
   } else {
      mgc_transaction_id++;
   }
   
   /* Create a new Request ID. */
   if (mgc_request_id == 999999) {
      mgc_request_id = 1;
   } else {
      mgc_request_id++;
   }

   strcpy(new_MG_info->ui.event, "key/kd");
   new_MG_info->ui.status = mgc_request_id;
   
   /* Set parameters of the Modify message. */
   strcpy(modify_param.mgc_ip_address, mgc_ip_string);
   strcpy(modify_param.mgc_udp_port, mgc_udp_string);
   sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
   modify_param.event_exist = 1;
   strcpy(modify_param.event_context_id, "-");
   strcpy(modify_param.event_termination_id, "ui");
   sprintf(modify_param.event_request_id, "%d", mgc_request_id);
   strcpy(modify_param.event, "key/kd");
   
   /* Send Modify message to message queue. */
   memset(megaco_msg, 0, MAX_MSG_SIZE);
   compose_modify(&modify_param, megaco_msg);
   add_msg_to_queue(mgc_transaction_id,
	                megaco_msg,
					parameters->mg_ip_address,
					new_MG_info->ptr_megaco_req_msg);
   
   if (VERBOSE) {
      printf("MGC: Out servicechange_process().\n");
   }
   
   FOUT;
}

/* --------------------------------------------------------------------------------------- 
 *  Process Notify Request
 * --------------------------------------------------------------------------------------*/
void notify_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMG1Exist;
   Boolean          bMG2Exist;
   Boolean          bMG3Exist;
   STRUCT_MEGACO_MG *MG_info1;
   STRUCT_MEGACO_MG *MG_info2;
   STRUCT_MEGACO_MG *MG_info3;
   
   char             megaco_msg[MAX_MSG_SIZE];
   STRUCT_MEGACO_ADD_PARAM add_param;
   STRUCT_MEGACO_MOVE_PARAM move_param;
   STRUCT_MEGACO_MODIFY_PARAM modify_param;
   STRUCT_MEGACO_NOTIFY_PARAM notify_param;
   STRUCT_MEGACO_SUBTRACT_PARAM subtract_param;
   STRUCT_MEGACO_AUDITVALUE_PARAM av_param;
   
   FIN(notify_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into notify_process().\n");
   }

   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->request_id_valid ||
	   !parameters->termination_id1_valid ||
	   !parameters->detection_time_valid ||
	   !parameters->detection_event_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Notify parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* If user enters a destination IP address, then check it. */
   if (!strcmp(parameters->detection_event, "dd/ce") &&
	   !parameters->dest_ip_address_valid) {
   
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Notify (destination IP) parameter!",
				 OPC_NIL,
				 OPC_NIL);
   }

   /* Find the specified MG. */
   bMG1Exist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info1 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info1->ip_string, parameters->mg_ip_address))
	  {  
         bMG1Exist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMG1Exist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Set the Notify parameters */
   memset(&notify_param, 0, sizeof(STRUCT_MEGACO_NOTIFY_PARAM));
   strcpy(notify_param.mgc_ip_address, mgc_ip_string);
   strcpy(notify_param.mgc_udp_port, mgc_udp_string);
   strcpy(notify_param.transaction_id, parameters->transaction_id);
   strcpy(notify_param.context_id, parameters->context_id);
   notify_param.num_command = 1;
   strcpy(notify_param.termination_id1, parameters->termination_id1);
   
   /* Send Notify message to MG. */
   memset(megaco_msg, 0, MAX_MSG_SIZE);
   compose_notify(&notify_param, megaco_msg);
   send_to_MG(megaco_msg, parameters->mg_ip_address, MG_info1->ptr_megaco_reply_msg);
   
   /* Find out what event just happens, and respond accordingly */
   if (!strcmp(parameters->detection_event, "key/kd")) {

      if ((MG_info1->ui.status != 0) && (!strcmp(MG_info1->ui.event, "key/kd"))) {
	  
	     if (MG_info1->at.status == 0) {
		 
		    /* Just pick up the phone, and ready to dial */

            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
   
            /* Create a new Request ID. */
            if (mgc_request_id == 999999) {
               mgc_request_id = 1;
            } else {
               mgc_request_id++;
            }
		 
			/* Set the MG */
			MG_info1->ui.status = mgc_request_id;
			strcpy(MG_info1->ui.event, "key/ku, dd/ce");
			MG_info1->at.status = 1;
			strcpy(MG_info1->at.signal, "cg/dt");
			
            /* Set the Modify parameters */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
            modify_param.event_exist = 1;
            strcpy(modify_param.event_context_id, "-");
            strcpy(modify_param.event_termination_id, "ui");
            sprintf(modify_param.event_request_id, "%d", mgc_request_id);
            strcpy(modify_param.event, "key/ku, dd/ce");
            modify_param.signal_exist = 1;
            strcpy(modify_param.signal_context_id, "-");
            strcpy(modify_param.signal_termination_id, "at/hf");
            strcpy(modify_param.signal, "cg/dt");
   
            /* Send Modify message to MG. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
				             megaco_msg,
							 parameters->mg_ip_address,
				             MG_info1->ptr_megaco_req_msg);
		 
		 } else {
		 
		    /* Answering the call */
		 
		    if ((MG_info1->rtp.status == 0) || (MG_info1->rtp1.status == 0)) {
			
			   if (VERBOSE) {
			      printf("MGC ERROR: The RTP status of both parties are incorrect.\n");
			   }
			   op_sim_end("MGC ERROR: ",
				          "Failed to set {key/ku, key/kf} for both parties!",
						  OPC_NIL,
						  OPC_NIL);
			}
			
            /* Find the specified MG. */
			bMG2Exist = OPC_FALSE;
            list_size = op_prg_list_size(ptr_MG_list);
            for (i = 0; i < list_size; i++)
            {     
               MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
               if (!strcmp(MG_info2->ip_string, MG_info1->rtp1.ip_string))
               {  
                  bMG2Exist = OPC_TRUE;
		          break;
               }
            }
   
            if (!bMG2Exist) {
   
               if (VERBOSE) {
        	      printf("MGC ERROR: Failed to locate the second MG (%s).\n", MG_info1->rtp1.ip_string);
	           }
          	   op_sim_end("MGC ERROR: ",
		                  "Failed to locate the MG!",
				          OPC_NIL,
           		          OPC_NIL);
            }
			
            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
   
            /* Create a new Request ID. */
            if (mgc_request_id == 999999) {
               mgc_request_id = 1;
            } else {
               mgc_request_id++;
            }
		 
			/* Set the first MG */
			strcpy(MG_info1->ui.event, "key/ku, key/kf");
			MG_info1->ui.status = mgc_request_id;
			(MG_info1->at.signal)[0] = '\0';
			MG_info1->at.status = 0;
			MG_info1->talking_party = 1;
			
            /* Set the first Modify parameters */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
            modify_param.event_exist = 1;
            strcpy(modify_param.event_context_id, "-");
            strcpy(modify_param.event_termination_id, "ui");
            sprintf(modify_param.event_request_id, "%d", mgc_request_id);
            strcpy(modify_param.event, "key/ku, key/kf");
            modify_param.signal_exist = 1;
            strcpy(modify_param.signal_context_id, MG_info1->rtp1.context_id);
            strcpy(modify_param.signal_termination_id, "at/hf");
            (modify_param.signal)[0] = '\0';
   
            /* Send Modify message to first MG. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
				             megaco_msg,
							 MG_info1->ip_string,
				             MG_info1->ptr_megaco_req_msg);
		 
            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
   
            /* Create a new Request ID. */
            if (mgc_request_id == 999999) {
               mgc_request_id = 1;
            } else {
               mgc_request_id++;
            }
		 
			/* Set the second MG */
			strcpy(MG_info2->ui.event, "key/ku, key/kf");
			MG_info2->ui.status = mgc_request_id;
			(MG_info2->at.signal)[0] = '\0';
			MG_info2->at.status = 0;
			MG_info2->talking_party = 1;
			
            /* Set the second Modify parameters */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
            modify_param.event_exist = 1;
            strcpy(modify_param.event_context_id, "-");
            strcpy(modify_param.event_termination_id, "ui");
            sprintf(modify_param.event_request_id, "%d", mgc_request_id);
            strcpy(modify_param.event, "key/ku, key/kf");
            modify_param.signal_exist = 1;
            strcpy(modify_param.signal_context_id, MG_info2->rtp1.context_id);
            strcpy(modify_param.signal_termination_id, "at/hf");
            (modify_param.signal)[0] = '\0';
			modify_param.rtp_exist = 1;
			strcpy(modify_param.rtp_context_id, MG_info2->rtp1.context_id);
			strcpy(modify_param.rtp_termination_id, "tr");
			modify_param.rtp_localcontrol_exist = 1;
			strcpy(modify_param.rtp_localcontrol_mode, "SendReceive");
   
            /* Send Modify message to MG. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
				             megaco_msg,
							 MG_info2->ip_string,
				             MG_info2->ptr_megaco_req_msg);
		 }
	  }

   }
   else if (!strcmp(parameters->detection_event, "key/ku"))
   {
      if ((MG_info1->ui.status != 0) && (!strcmp(MG_info1->ui.event, "key/ku, dd/ce"))) {

	     /* User just pick up the phone without connecting, then hang up. */
	  
         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
   
         /* Create a new Request ID. */
         if (mgc_request_id == 999999) {
            mgc_request_id = 1;
         } else {
            mgc_request_id++;
         }
	  
         strcpy(MG_info1->ui.event, "key/kd");
         MG_info1->ui.status = mgc_request_id;
		 (MG_info1->at.signal)[0] = '\0';
		 MG_info1->at.status = 0;
   
         /* Set parameters of the Modify message. */
         memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
         strcpy(modify_param.mgc_ip_address, mgc_ip_string);
         strcpy(modify_param.mgc_udp_port, mgc_udp_string);
         sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
         modify_param.event_exist = 1;
         strcpy(modify_param.event_context_id, "-");
         strcpy(modify_param.event_termination_id, "ui");
         sprintf(modify_param.event_request_id, "%d", mgc_request_id);
         strcpy(modify_param.event, "key/kd");
         modify_param.signal_exist = 1;
         strcpy(modify_param.signal_context_id, "-");
         strcpy(modify_param.signal_termination_id, "at/hf");
         (modify_param.signal)[0] = '\0';		 
   
         /* Send Modify message to message queue. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_modify(&modify_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
	                      megaco_msg,
				          parameters->mg_ip_address,
					      MG_info1->ptr_megaco_req_msg);
	  
	  }
	  else if ((MG_info1->ui.status != 0) && (!strcmp(MG_info1->ui.event, "key/ku, key/kf")))
	  {

         /* Find the other connecting MG. */
	     if (MG_info1->rtp1.status != 0) {
		 
		    bMG2Exist = OPC_FALSE;
            list_size = op_prg_list_size(ptr_MG_list);
            for (i = 0; i < list_size; i++)
            {     
               MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
               if (!strcmp(MG_info2->ip_string, MG_info1->rtp1.ip_string))
               {  
                  bMG2Exist = OPC_TRUE;
                  break;
               }
            }
   
            if (!bMG2Exist) {
   
               if (VERBOSE) {
	              printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info1->rtp1.ip_string);
               }
               op_sim_end("MGC ERROR: ",
		                  "Failed to locate the MG!",
                          OPC_NIL,
                          OPC_NIL);
            }
		 
		    if ((MG_info2->rtp1.status != 0) && (MG_info2->rtp2.status != 0)) {
			
			   if ((((MG_info2->talking_party == 1) ||
				     ((MG_info2->talking_party == 0) && (MG_info2->rtp.waiting_party == 1))) &&
				    (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string))) ||
				   (((MG_info2->talking_party == 2) ||
					 ((MG_info2->talking_party == 0) && (MG_info2->rtp.waiting_party == 2))) &&
					 (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)))) {
			   
			      int move_to = 0;
				  
				  if (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string)) {
				  
				     move_to = 2;
					 
					 bMG3Exist = OPC_FALSE;
                     list_size = op_prg_list_size(ptr_MG_list);
                     for (i = 0; i < list_size; i++)
                     {     
                        MG_info3 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
                        if (!strcmp(MG_info3->ip_string, MG_info2->rtp2.ip_string))
                        {  
                           bMG3Exist = OPC_TRUE;
                           break;
                        }
                     }
   
                     if (!bMG3Exist) {
   
                        if (VERBOSE) {
	                       printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info2->rtp2.ip_string);
                        }
                        op_sim_end("MGC ERROR: ",
		                           "Failed to locate the MG!",
                                   OPC_NIL,
                                   OPC_NIL);
                     }
					 
				  } else if (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)) {
				  
				     move_to = 1;
					 
					 bMG3Exist = OPC_FALSE;
                     list_size = op_prg_list_size(ptr_MG_list);
                     for (i = 0; i < list_size; i++)
                     {     
                        MG_info3 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
                        if (!strcmp(MG_info3->ip_string, MG_info2->rtp1.ip_string))
                        {  
                           bMG3Exist = OPC_TRUE;
                           break;
                        }
                     }
   
                     if (!bMG3Exist) {
   
                        if (VERBOSE) {
	                       printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info2->rtp1.ip_string);
                        }
                        op_sim_end("MGC ERROR: ",
		                           "Failed to locate the MG!",
                                   OPC_NIL,
                                   OPC_NIL);
                     }
				  }
			   
                  /* Create a new Transaction ID. */
                  if (mgc_transaction_id == 999999) {
                     mgc_transaction_id = 1;
                  } else {
                     mgc_transaction_id++;
                  }
		 
		          if (MG_info3->talking_party != 0) {
		 
		             if (VERBOSE) {
			            printf("MGC Info: The party (%s) I am switching to is talking, so silent.\n",
				               MG_info3->rtp.ip_string);
			         }
		 
					 (MG_info2->at.signal)[0] = '\0';
					 MG_info2->at.status = 0;
		             MG_info2->rtp.waiting_party = move_to;
	                 MG_info2->talking_party = 0;
			
                     /* Set parameters of the Modify message. */
                     memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
                     strcpy(move_param.mgc_ip_address, mgc_ip_string);
                     strcpy(move_param.mgc_udp_port, mgc_udp_string);
                     sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
					 if (move_to == 1) {
                        strcpy(move_param.context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
					    strcpy(move_param.context_id, MG_info2->rtp2.context_id);
					 }
					 
                     move_param.signal_exist = 1;
                     strcpy(move_param.signal_termination_id, "at/hf");
                     (move_param.signal)[0] = '\0';
			         move_param.rtp_exist = 1;
			         strcpy(move_param.rtp_termination_id, "tr");
                     move_param.rtp_localcontrol_exist = 1;
                     strcpy(move_param.rtp_localcontrol_mode, "ReceiveOnly");
			         move_param.rtp_remote_exist = 1;
					 if (move_to == 1) {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp1.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp1.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp1.codec);
					 } else {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp2.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp2.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp2.codec);
					 }
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_move(&move_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info2->ip_string,
 				             MG_info2->ptr_megaco_req_msg);
      		      } else {
		 
		             if (VERBOSE) {
			            printf("MGC Info: I am switching to party (%s).\n",
				               MG_info3->rtp.ip_string);
			         }
		 
					 (MG_info2->at.signal)[0] = '\0';
					 MG_info2->at.status = 0;
		             MG_info2->talking_party = move_to;
			
                     /* Set parameters of the Modify message. */
                     memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
                     strcpy(move_param.mgc_ip_address, mgc_ip_string);
                     strcpy(move_param.mgc_udp_port, mgc_udp_string);
                     sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
					 if (move_to == 1) {
                        strcpy(move_param.context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
					    strcpy(move_param.context_id, MG_info2->rtp2.context_id);
					 }
			
                     move_param.signal_exist = 1;
                     strcpy(move_param.signal_termination_id, "at/hf");
			         (move_param.signal)[0] = '\0';
			         move_param.rtp_exist = 1;
			         strcpy(move_param.rtp_termination_id, "tr");
			         move_param.rtp_localcontrol_exist = 1;
			         strcpy(move_param.rtp_localcontrol_mode, "SendReceive");
			         move_param.rtp_remote_exist = 1;
					 if (move_to == 1) {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp1.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp1.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp1.codec);
					 } else {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp2.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp2.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp2.codec);
					 }
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_move(&move_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
                                      megaco_msg,
 			                          MG_info2->ip_string,
 				                      MG_info2->ptr_megaco_req_msg);

                     /* Create a new Transaction ID. */
                     if (mgc_transaction_id == 999999) {
                        mgc_transaction_id = 1;
                     } else {
                        mgc_transaction_id++;
                     }
			
                     /* Create a new Request ID. */
                     if (mgc_request_id == 999999) {
                        mgc_request_id = 1;
                     } else {
                        mgc_request_id++;
                     }
			
			         /* Set the MG */
			         strcpy(MG_info3->ui.event, "key/ku, key/kf");
			         MG_info3->ui.status = mgc_request_id;
			         (MG_info3->at.signal)[0] = '\0';
			         MG_info3->at.status = 0;
			         if (!strcmp(MG_info3->rtp1.ip_string, MG_info2->rtp.ip_string)) {
			            MG_info3->talking_party = 1;
			         } else if (!strcmp(MG_info3->rtp2.ip_string, MG_info2->rtp.ip_string)) {
			            MG_info3->talking_party = 2;
			         } else {
			
			            if (VERBOSE) {
			               printf("MGC ERROR: Invalid switching operation.\n");
			            }
			            op_sim_end("MGC ERROR: ",
				                   "Invalid switching operation!\n",
						           OPC_NIL,
						           OPC_NIL);
			         }

                     /* Set parameters of the Modify message. */
                     memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
                     strcpy(modify_param.mgc_ip_address, mgc_ip_string);
                     strcpy(modify_param.mgc_udp_port, mgc_udp_string);
                     sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
			         modify_param.event_exist = 1;
                     strcpy(modify_param.event_context_id, "-");
                     strcpy(modify_param.event_termination_id, "ui");
                     sprintf(modify_param.event_request_id, "%d", mgc_request_id);
                     strcpy(modify_param.event, "key/ku, key/kf");
                     modify_param.signal_exist = 1;
					 if (move_to == 1) {
                        strcpy(modify_param.signal_context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
                        strcpy(modify_param.signal_context_id, MG_info2->rtp2.context_id);
					 }
                     strcpy(modify_param.signal_termination_id, "at/hf");
                     (modify_param.signal)[0] = '\0';
                     modify_param.rtp_exist = 1;
					 if (move_to == 1) {
                        strcpy(modify_param.rtp_context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
                        strcpy(modify_param.rtp_context_id, MG_info2->rtp2.context_id);
					 }
                     strcpy(modify_param.rtp_termination_id, "tr");
                     modify_param.rtp_localcontrol_exist = 1;
                     strcpy(modify_param.rtp_localcontrol_mode, "SendReceive");
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_modify(&modify_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
	                                  megaco_msg,
		     		                  MG_info3->rtp.ip_string,
			                          MG_info3->ptr_megaco_req_msg);
		          }
			   }
		 
		       /* Clear up the context in the second MG since one connection is no longer existed */
		       if (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string)) {
			   
			      (MG_info2->rtp1.ip_string)[0] = '\0';
                  (MG_info2->rtp1.udp_string)[0] = '\0';
                  (MG_info2->rtp1.codec)[0] = '\0';
                  (MG_info2->rtp1.context_id)[0] = '\0';
                  MG_info2->rtp1.waiting_party = 0;
                  MG_info2->rtp1.status = 0;
			   
			   } else if (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)) {
			   
			      (MG_info2->rtp2.ip_string)[0] = '\0';
                  (MG_info2->rtp2.udp_string)[0] = '\0';
                  (MG_info2->rtp2.codec)[0] = '\0';
                  (MG_info2->rtp2.context_id)[0] = '\0';
                  MG_info2->rtp2.waiting_party = 0;
                  MG_info2->rtp2.status = 0;
			   }
		 
		    } else {
			
			   /* Create a new Transaction ID. */
               if (mgc_transaction_id == 999999) {
                  mgc_transaction_id = 1;
               } else {
                  mgc_transaction_id++;
               }
			   
               /* Set parameters of the Subtract message. */
               memset(&subtract_param, 0, sizeof(STRUCT_MEGACO_SUBTRACT_PARAM));
               strcpy(subtract_param.mgc_ip_address, mgc_ip_string);
               strcpy(subtract_param.mgc_udp_port, mgc_udp_string);
               sprintf(subtract_param.transaction_id, "%d", mgc_transaction_id);
			   subtract_param.num_command = 2;
			   strcpy(subtract_param.termination_id1, "at/hf");
			   strcpy(subtract_param.termination_id2, "tr");
			   if (MG_info2->rtp1.status != 0) {
                  strcpy(subtract_param.context_id, MG_info2->rtp1.context_id);
			   } else if (MG_info2->rtp2.status != 0) {
                  strcpy(subtract_param.context_id, MG_info2->rtp2.context_id);
			   }
   
               /* Send Modify message to message queue. */
               memset(megaco_msg, 0, MAX_MSG_SIZE);
               compose_subtract(&subtract_param, megaco_msg);
               add_msg_to_queue(mgc_transaction_id,
	                            megaco_msg,
				                MG_info2->ip_string,
					            MG_info2->ptr_megaco_req_msg);

			
               /* Create a new Transaction ID. */
               if (mgc_transaction_id == 999999) {
                  mgc_transaction_id = 1;
               } else {
                  mgc_transaction_id++;
               }
   
               /* Create a new Request ID. */
               if (mgc_request_id == 999999) {
                  mgc_request_id = 1;
               } else {
                  mgc_request_id++;
               }
	  
               /* Set parameters of the Modify message. */
               memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
               strcpy(modify_param.mgc_ip_address, mgc_ip_string);
               strcpy(modify_param.mgc_udp_port, mgc_udp_string);
               sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
               modify_param.event_exist = 1;
               strcpy(modify_param.event_context_id, "-");
               strcpy(modify_param.event_termination_id, "ui");
               sprintf(modify_param.event_request_id, "%d", mgc_request_id);
               strcpy(modify_param.event, "key/kd");
               modify_param.signal_exist = 1;
               strcpy(modify_param.signal_context_id, "-");
               strcpy(modify_param.signal_termination_id, "at/hf");
               (modify_param.signal)[0] = '\0';		 
   
               /* Send Modify message to message queue. */
               memset(megaco_msg, 0, MAX_MSG_SIZE);
               compose_modify(&modify_param, megaco_msg);
               add_msg_to_queue(mgc_transaction_id,
	                            megaco_msg,
				                MG_info2->ip_string,
					            MG_info2->ptr_megaco_req_msg);
			   
			   /* Reset the MG */
               strcpy(MG_info2->ui.event, "key/kd");
               MG_info2->ui.status = mgc_request_id;
		       (MG_info2->at.signal)[0] = '\0';
		       MG_info2->at.status = 0;
			   MG_info2->talking_party = 0;
			   (MG_info2->rtp.ip_string)[0] = '\0';
			   (MG_info2->rtp.udp_string)[0] = '\0';
			   (MG_info2->rtp.codec)[0] = '\0';
			   (MG_info2->rtp.context_id)[0] = '\0';
			   MG_info2->rtp.status = 0;
			   MG_info2->rtp.waiting_party = 0;
			   (MG_info2->rtp1.ip_string)[0] = '\0';
			   (MG_info2->rtp1.udp_string)[0] = '\0';
			   (MG_info2->rtp1.codec)[0] = '\0';
			   (MG_info2->rtp1.context_id)[0] = '\0';
			   MG_info2->rtp1.status = 0;
			   MG_info2->rtp1.waiting_party = 0;
			   (MG_info2->rtp2.ip_string)[0] = '\0';
			   (MG_info2->rtp2.udp_string)[0] = '\0';
			   (MG_info2->rtp2.codec)[0] = '\0';
			   (MG_info2->rtp2.context_id)[0] = '\0';
			   MG_info2->rtp2.status = 0;
			   MG_info2->rtp2.waiting_party = 0;
		    }	  
         }		 
   
         /* Find the other connecting MG. */
		 if (MG_info1->rtp2.status != 0) {

		    bMG2Exist = OPC_FALSE;
            list_size = op_prg_list_size(ptr_MG_list);
            for (i = 0; i < list_size; i++)
            {     
               MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
               if (!strcmp(MG_info2->ip_string, MG_info1->rtp2.ip_string))
               {  
                  bMG2Exist = OPC_TRUE;
                  break;
               }
            }
   
            if (!bMG2Exist) {
   
               if (VERBOSE) {
	              printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info1->rtp2.ip_string);
               }
               op_sim_end("MGC ERROR: ",
		                  "Failed to locate the MG!",
                          OPC_NIL,
                          OPC_NIL);
            }
		 
		    if ((MG_info2->rtp1.status != 0) && (MG_info2->rtp2.status != 0)) {

			   if ((((MG_info2->talking_party == 1) ||
				     ((MG_info2->talking_party == 0) && (MG_info2->rtp.waiting_party == 1))) &&
				    (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string))) ||
				   (((MG_info2->talking_party == 2) ||
					 ((MG_info2->talking_party == 0) && (MG_info2->rtp.waiting_party == 2))) &&
					 (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)))) {
			   
			      int move_to = 0;
				  
				  if (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string)) {
				  
				     move_to = 2;
					 
					 bMG3Exist = OPC_FALSE;
                     list_size = op_prg_list_size(ptr_MG_list);
                     for (i = 0; i < list_size; i++)
                     {     
                        MG_info3 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
                        if (!strcmp(MG_info3->ip_string, MG_info2->rtp2.ip_string))
                        {  
                           bMG3Exist = OPC_TRUE;
                           break;
                        }
                     }
   
                     if (!bMG3Exist) {
   
                        if (VERBOSE) {
	                       printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info2->rtp2.ip_string);
                        }
                        op_sim_end("MGC ERROR: ",
		                           "Failed to locate the MG!",
                                   OPC_NIL,
                                   OPC_NIL);
                     }
					 
				  } else if (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)) {
				  
				     move_to = 1;
					 
					 bMG3Exist = OPC_FALSE;
                     list_size = op_prg_list_size(ptr_MG_list);
                     for (i = 0; i < list_size; i++)
                     {     
                        MG_info3 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
                        if (!strcmp(MG_info3->ip_string, MG_info2->rtp1.ip_string))
                        {  
                           bMG3Exist = OPC_TRUE;
                           break;
                        }
                     }
   
                     if (!bMG3Exist) {
   
                        if (VERBOSE) {
	                       printf("MGC ERROR: Failed to locate MG (%s).\n", MG_info2->rtp1.ip_string);
                        }
                        op_sim_end("MGC ERROR: ",
		                           "Failed to locate the MG!",
                                   OPC_NIL,
                                   OPC_NIL);
                     }
				  }
			   
                  /* Create a new Transaction ID. */
                  if (mgc_transaction_id == 999999) {
                     mgc_transaction_id = 1;
                  } else {
                     mgc_transaction_id++;
                  }
		 
		          if (MG_info3->talking_party != 0) {
		 
		             if (VERBOSE) {
			            printf("MGC Info: The party (%s) I am switching to is talking, so silent.\n",
				               MG_info3->rtp.ip_string);
			         }
		 
					 (MG_info2->at.signal)[0] = '\0';
					 MG_info2->at.status = 0;
		             MG_info2->rtp.waiting_party = move_to;
	                 MG_info2->talking_party = 0;
			
                     /* Set parameters of the Modify message. */
                     memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
                     strcpy(move_param.mgc_ip_address, mgc_ip_string);
                     strcpy(move_param.mgc_udp_port, mgc_udp_string);
                     sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
					 if (move_to == 1) {
                        strcpy(move_param.context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
					    strcpy(move_param.context_id, MG_info2->rtp2.context_id);
					 }
					 
                     move_param.signal_exist = 1;
                     strcpy(move_param.signal_termination_id, "at/hf");
                     (move_param.signal)[0] = '\0';
			         move_param.rtp_exist = 1;
			         strcpy(move_param.rtp_termination_id, "tr");
                     move_param.rtp_localcontrol_exist = 1;
                     strcpy(move_param.rtp_localcontrol_mode, "ReceiveOnly");
			         move_param.rtp_remote_exist = 1;
					 if (move_to == 1) {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp1.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp1.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp1.codec);
					 } else {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp2.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp2.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp2.codec);
					 }
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_move(&move_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info2->ip_string,
 				             MG_info2->ptr_megaco_req_msg);
			
      		      } else {
		 
		             if (VERBOSE) {
			            printf("MGC Info: I am switching to party (%s).\n",
				               MG_info3->rtp.ip_string);
			         }
		 
					 (MG_info2->at.signal)[0] = '\0';
					 MG_info2->at.status = 0;
		             MG_info2->talking_party = move_to;
			
                     /* Set parameters of the Modify message. */
                     memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
                     strcpy(move_param.mgc_ip_address, mgc_ip_string);
                     strcpy(move_param.mgc_udp_port, mgc_udp_string);
                     sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
					 if (move_to == 1) {
                        strcpy(move_param.context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
					    strcpy(move_param.context_id, MG_info2->rtp2.context_id);
					 }
			
                     move_param.signal_exist = 1;
                     strcpy(move_param.signal_termination_id, "at/hf");
			         (move_param.signal)[0] = '\0';
			         move_param.rtp_exist = 1;
			         strcpy(move_param.rtp_termination_id, "tr");
			         move_param.rtp_localcontrol_exist = 1;
			         strcpy(move_param.rtp_localcontrol_mode, "SendReceive");
			         move_param.rtp_remote_exist = 1;
					 if (move_to == 1) {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp1.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp1.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp1.codec);
					 } else {
			            strcpy(move_param.rtp_remote_address, MG_info2->rtp2.ip_string);
			            strcpy(move_param.rtp_remote_port, MG_info2->rtp2.udp_string);
			            strcpy(move_param.rtp_remote_codec, MG_info2->rtp2.codec);
					 }
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_move(&move_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
                                      megaco_msg,
 			                          MG_info2->ip_string,
 				                      MG_info2->ptr_megaco_req_msg);

                     /* Create a new Transaction ID. */
                     if (mgc_transaction_id == 999999) {
                        mgc_transaction_id = 1;
                     } else {
                        mgc_transaction_id++;
                     }
			
                     /* Create a new Request ID. */
                     if (mgc_request_id == 999999) {
                        mgc_request_id = 1;
                     } else {
                        mgc_request_id++;
                     }
			
			         /* Set the MG */
			         strcpy(MG_info3->ui.event, "key/ku, key/kf");
			         MG_info3->ui.status = mgc_request_id;
			         (MG_info3->at.signal)[0] = '\0';
			         MG_info3->at.status = 0;
			         if (!strcmp(MG_info3->rtp1.ip_string, MG_info2->rtp.ip_string)) {
			            MG_info3->talking_party = 1;
			         } else if (!strcmp(MG_info3->rtp2.ip_string, MG_info2->rtp.ip_string)) {
			            MG_info3->talking_party = 2;
			         } else {
			
			            if (VERBOSE) {
			               printf("MGC ERROR: Invalid switching operation.\n");
			            }
			            op_sim_end("MGC ERROR: ",
				                   "Invalid switching operation!\n",
						           OPC_NIL,
						           OPC_NIL);
			         }

                     /* Set parameters of the Modify message. */
                     memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
                     strcpy(modify_param.mgc_ip_address, mgc_ip_string);
                     strcpy(modify_param.mgc_udp_port, mgc_udp_string);
                     sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
			         modify_param.event_exist = 1;
                     strcpy(modify_param.event_context_id, "-");
                     strcpy(modify_param.event_termination_id, "ui");
                     sprintf(modify_param.event_request_id, "%d", mgc_request_id);
                     strcpy(modify_param.event, "key/ku, key/kf");
                     modify_param.signal_exist = 1;
					 if (move_to == 1) {
                        strcpy(modify_param.signal_context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
                        strcpy(modify_param.signal_context_id, MG_info2->rtp2.context_id);
					 }
                     strcpy(modify_param.signal_termination_id, "at/hf");
                     (modify_param.signal)[0] = '\0';
                     modify_param.rtp_exist = 1;
					 if (move_to == 1) {
                        strcpy(modify_param.rtp_context_id, MG_info2->rtp1.context_id);
					 } else if (move_to == 2) {
                        strcpy(modify_param.rtp_context_id, MG_info2->rtp2.context_id);
					 }
                     strcpy(modify_param.rtp_termination_id, "tr");
                     modify_param.rtp_localcontrol_exist = 1;
                     strcpy(modify_param.rtp_localcontrol_mode, "SendReceive");
		 
                     /* Send Modify message to message queue. */
                     memset(megaco_msg, 0, MAX_MSG_SIZE);
                     compose_modify(&modify_param, megaco_msg);
                     add_msg_to_queue(mgc_transaction_id,
	                                  megaco_msg,
		     		                  MG_info3->rtp.ip_string,
			                          MG_info3->ptr_megaco_req_msg);

		          }
			   }

		       /* Clear up the context in the second MG since one connection is no longer existed */
		       if (!strcmp(MG_info1->ip_string, MG_info2->rtp1.ip_string)) {
			   
			      (MG_info2->rtp1.ip_string)[0] = '\0';
                  (MG_info2->rtp1.udp_string)[0] = '\0';
                  (MG_info2->rtp1.codec)[0] = '\0';
                  (MG_info2->rtp1.context_id)[0] = '\0';
                  MG_info2->rtp1.waiting_party = 0;
                  MG_info2->rtp1.status = 0;
			   
			   } else if (!strcmp(MG_info1->ip_string, MG_info2->rtp2.ip_string)) {
			   
			      (MG_info2->rtp2.ip_string)[0] = '\0';
                  (MG_info2->rtp2.udp_string)[0] = '\0';
                  (MG_info2->rtp2.codec)[0] = '\0';
                  (MG_info2->rtp2.context_id)[0] = '\0';
                  MG_info2->rtp2.waiting_party = 0;
                  MG_info2->rtp2.status = 0;
			   }
			   
		    } else {

			   /* Create a new Transaction ID. */
               if (mgc_transaction_id == 999999) {
                  mgc_transaction_id = 1;
               } else {
                  mgc_transaction_id++;
               }
			   
               /* Set parameters of the Subtract message. */
               memset(&subtract_param, 0, sizeof(STRUCT_MEGACO_SUBTRACT_PARAM));
               strcpy(subtract_param.mgc_ip_address, mgc_ip_string);
               strcpy(subtract_param.mgc_udp_port, mgc_udp_string);
               sprintf(subtract_param.transaction_id, "%d", mgc_transaction_id);
			   subtract_param.num_command = 2;
			   strcpy(subtract_param.termination_id1, "at/hf");
			   strcpy(subtract_param.termination_id2, "tr");
			   if (MG_info2->rtp1.status != 0) {
                  strcpy(subtract_param.context_id, MG_info2->rtp1.context_id);
			   } else if (MG_info2->rtp2.status != 0) {
                  strcpy(subtract_param.context_id, MG_info2->rtp2.context_id);
			   }
   
               /* Send Modify message to message queue. */
               memset(megaco_msg, 0, MAX_MSG_SIZE);
               compose_subtract(&subtract_param, megaco_msg);
               add_msg_to_queue(mgc_transaction_id,
	                            megaco_msg,
				                MG_info2->ip_string,
					            MG_info2->ptr_megaco_req_msg);

			
               /* Create a new Transaction ID. */
               if (mgc_transaction_id == 999999) {
                  mgc_transaction_id = 1;
               } else {
                  mgc_transaction_id++;
               }
   
               /* Create a new Request ID. */
               if (mgc_request_id == 999999) {
                  mgc_request_id = 1;
               } else {
                  mgc_request_id++;
               }
	  
               /* Set parameters of the Modify message. */
               memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
               strcpy(modify_param.mgc_ip_address, mgc_ip_string);
               strcpy(modify_param.mgc_udp_port, mgc_udp_string);
               sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
               modify_param.event_exist = 1;
               strcpy(modify_param.event_context_id, "-");
               strcpy(modify_param.event_termination_id, "ui");
               sprintf(modify_param.event_request_id, "%d", mgc_request_id);
               strcpy(modify_param.event, "key/kd");
               modify_param.signal_exist = 1;
               strcpy(modify_param.signal_context_id, "-");
               strcpy(modify_param.signal_termination_id, "at/hf");
               (modify_param.signal)[0] = '\0';		 
   
               /* Send Modify message to message queue. */
               memset(megaco_msg, 0, MAX_MSG_SIZE);
               compose_modify(&modify_param, megaco_msg);
               add_msg_to_queue(mgc_transaction_id,
	                            megaco_msg,
				                MG_info2->ip_string,
					            MG_info2->ptr_megaco_req_msg);
			   
			   /* Reset the MG */
               strcpy(MG_info2->ui.event, "key/kd");
               MG_info2->ui.status = mgc_request_id;
		       (MG_info2->at.signal)[0] = '\0';
		       MG_info2->at.status = 0;
			   MG_info2->talking_party = 0;
			   (MG_info2->rtp.ip_string)[0] = '\0';
			   (MG_info2->rtp.udp_string)[0] = '\0';
			   (MG_info2->rtp.codec)[0] = '\0';
			   (MG_info2->rtp.context_id)[0] = '\0';
			   MG_info2->rtp.status = 0;
			   MG_info2->rtp.waiting_party = 0;
			   (MG_info2->rtp1.ip_string)[0] = '\0';
			   (MG_info2->rtp1.udp_string)[0] = '\0';
			   (MG_info2->rtp1.codec)[0] = '\0';
			   (MG_info2->rtp1.context_id)[0] = '\0';
			   MG_info2->rtp1.status = 0;
			   MG_info2->rtp1.waiting_party = 0;
			   (MG_info2->rtp2.ip_string)[0] = '\0';
			   (MG_info2->rtp2.udp_string)[0] = '\0';
			   (MG_info2->rtp2.codec)[0] = '\0';
			   (MG_info2->rtp2.context_id)[0] = '\0';
			   MG_info2->rtp2.status = 0;
			   MG_info2->rtp2.waiting_party = 0;
		    }
		 }
		 
		 /* Shuting itself down */
		 
		 /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
			   
         /* Set parameters of the Subtract message. */
         memset(&subtract_param, 0, sizeof(STRUCT_MEGACO_SUBTRACT_PARAM));
         strcpy(subtract_param.mgc_ip_address, mgc_ip_string);
         strcpy(subtract_param.mgc_udp_port, mgc_udp_string);
         sprintf(subtract_param.transaction_id, "%d", mgc_transaction_id);
		 subtract_param.num_command = 2;
		 strcpy(subtract_param.termination_id1, "at/hf");
		 strcpy(subtract_param.termination_id2, "tr");
		 if ((MG_info1->talking_party == 1) ||
			 ((MG_info1->talking_party == 0) &&
			  (MG_info1->rtp.waiting_party == 1))) {
            strcpy(subtract_param.context_id, MG_info1->rtp1.context_id);
		 } else if ((MG_info1->talking_party == 2) ||
			        ((MG_info1->talking_party == 0) &&
					 (MG_info1->rtp.waiting_party == 2))) {
            strcpy(subtract_param.context_id, MG_info2->rtp2.context_id);
		 }
   
         /* Send Modify message to message queue. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_subtract(&subtract_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
	                      megaco_msg,
				          MG_info1->ip_string,
					      MG_info1->ptr_megaco_req_msg);

			
         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
   
         /* Create a new Request ID. */
         if (mgc_request_id == 999999) {
            mgc_request_id = 1;
         } else {
            mgc_request_id++;
         }
	  
         /* Set parameters of the Modify message. */
         memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
         strcpy(modify_param.mgc_ip_address, mgc_ip_string);
         strcpy(modify_param.mgc_udp_port, mgc_udp_string);
         sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
         modify_param.event_exist = 1;
         strcpy(modify_param.event_context_id, "-");
         strcpy(modify_param.event_termination_id, "ui");
         sprintf(modify_param.event_request_id, "%d", mgc_request_id);
         strcpy(modify_param.event, "key/kd");
         modify_param.signal_exist = 1;
         strcpy(modify_param.signal_context_id, "-");
         strcpy(modify_param.signal_termination_id, "at/hf");
         (modify_param.signal)[0] = '\0';		 
   
         /* Send Modify message to message queue. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_modify(&modify_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
	                      megaco_msg,
				          MG_info1->ip_string,
					      MG_info1->ptr_megaco_req_msg);
			   
		 /* Reset the MG */
         strcpy(MG_info1->ui.event, "key/kd");
		 MG_info1->ui.status = mgc_request_id;
		 (MG_info1->at.signal)[0] = '\0';
		 MG_info1->at.status = 0;
		 MG_info1->talking_party = 0;
		 (MG_info1->rtp.ip_string)[0] = '\0';
		 (MG_info1->rtp.udp_string)[0] = '\0';
		 (MG_info1->rtp.codec)[0] = '\0';
		 (MG_info1->rtp.context_id)[0] = '\0';
		 MG_info1->rtp.status = 0;
		 MG_info1->rtp.waiting_party = 0;
		 (MG_info1->rtp1.ip_string)[0] = '\0';
		 (MG_info1->rtp1.udp_string)[0] = '\0';
		 (MG_info1->rtp1.codec)[0] = '\0';
		 (MG_info1->rtp1.context_id)[0] = '\0';
		 MG_info1->rtp1.status = 0;
		 MG_info1->rtp1.waiting_party = 0;
		 (MG_info1->rtp2.ip_string)[0] = '\0';
		 (MG_info1->rtp2.udp_string)[0] = '\0';
		 (MG_info1->rtp2.codec)[0] = '\0';
		 (MG_info1->rtp2.context_id)[0] = '\0';
		 MG_info1->rtp2.status = 0;
		 MG_info1->rtp2.waiting_party = 0;
	  }
   }
   else if (!strcmp(parameters->detection_event, "dd/ce"))
   {
   
      /* Dailing */
   
      /* Find the specified MG. */
	  bMG2Exist = OPC_FALSE;
      list_size = op_prg_list_size(ptr_MG_list);
      for (i = 0; i < list_size; i++)
      {     
         MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
         if (!strcmp(MG_info2->ip_string, parameters->dest_ip_address))
         {  
            bMG2Exist = OPC_TRUE;
		    break;
         }
      }
   
      if (!bMG2Exist) {
   
	     if (VERBOSE) {
            printf("MGC ERROR: Failed to locate the second MG (%s).\n", parameters->dest_ip_address);
	     }
         op_sim_end("MGC ERROR: ",
		            "Failed to locate the second MG!",
		            OPC_NIL,
                    OPC_NIL);
      }
			
	  /* Check if the other MG is available */
	  if ((MG_info2->rtp1.status != 0) && (MG_info2->rtp2.status != 0)) {
	  
	     if (VERBOSE) {
		    printf("MGC ERROR: The destination MG (%s) is busy.\n", MG_info2->ip_string);
		 }
		 op_sim_end("MGC ERROR: ",
			        "The destination MG is busy!",
					OPC_NIL,
					OPC_NIL);
	  }

      /* Create a new Transaction ID. */
      if (mgc_transaction_id == 999999) {
         mgc_transaction_id = 1;
      } else {
         mgc_transaction_id++;
      }

	  /* Create a new context ID. */
      if (mgc_context_id == 999999) {
	     mgc_context_id = 1;
      } else {
	     mgc_context_id++;
      }
	  
	  /* Determine if it will be a call-waiting. */
	  if (MG_info2->rtp.status != 0) {
	  
	     /* Call-waiting scenario */
	     strcpy(MG_info1->rtp1.ip_string, MG_info2->rtp.ip_string);
		 strcpy(MG_info1->rtp1.udp_string, MG_info2->rtp.udp_string);
		 strcpy(MG_info1->rtp1.codec, MG_info2->rtp.codec);
		 MG_info1->rtp1.status = 1;

	  } else {
	  
	     /* Regular call scenario */
	     strcpy(MG_info1->rtp1.ip_string, parameters->dest_ip_address);
	  }
	  
      sprintf(MG_info1->rtp1.context_id, "%d", mgc_context_id);
	  
	  /* Remove the dail-tone */
	  (MG_info1->at.signal)[0] = '\0';
	  MG_info1->at.status = 0;
	  
      /* Set the Add parameters */
      memset(&add_param, 0, sizeof(STRUCT_MEGACO_ADD_PARAM));
      strcpy(add_param.mgc_ip_address, mgc_ip_string);
      strcpy(add_param.mgc_udp_port, mgc_udp_string);
      sprintf(add_param.transaction_id, "%d", mgc_transaction_id);
	  sprintf(add_param.context_id, "%d", mgc_context_id);
      add_param.signal_exist = 1;
      strcpy(add_param.signal_termination_id, "at/hf");
      (add_param.signal)[0] = '\0';
	  add_param.rtp_exist = 1;
	  strcpy(add_param.rtp_termination_id, "tr");
	  add_param.rtp_localcontrol_exist = 1;
	  strcpy(add_param.rtp_localcontrol_mode, "ReceiveOnly");
	  add_param.rtp_local1_exist = 1;
	  add_param.rtp_local2_exist = 1;
   
      /* Send Add message to MG. */
      memset(megaco_msg, 0, MAX_MSG_SIZE);
      compose_add(&add_param, megaco_msg);
      add_msg_to_queue(mgc_transaction_id,
		               megaco_msg,
					   MG_info1->ip_string,
		               MG_info1->ptr_megaco_req_msg);
   
   } else if (!strcmp(parameters->detection_event, "key/kf")) {
   
      /* Call waiting, so switching */
   
   	  /* Check if the other MG is available */
	  if ((MG_info1->rtp.status == 0) ||
		  (MG_info1->rtp1.status == 0) ||
		  (MG_info1->rtp2.status == 0)) {
	  
	     if (VERBOSE) {
		    printf("MGC ERROR: The call-waiting MG (%s) does not have 2 lines.\n",
				   MG_info1->ip_string);
		 }
		 op_sim_end("MGC ERROR: ",
			        "The call-waiting MG does not have 2 lines!",
					OPC_NIL,
					OPC_NIL);
	  }

      /* Find the second MG. */
	  bMG2Exist = OPC_FALSE;
      list_size = op_prg_list_size(ptr_MG_list);
      for (i = 0; i < list_size; i++)
      {     
         MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
         if (!strcmp(MG_info2->ip_string, MG_info1->rtp1.ip_string))
         {  
            bMG2Exist = OPC_TRUE;
		    break;
         }
      }
   
      if (!bMG2Exist) {
   
	     if (VERBOSE) {
            printf("MGC ERROR: Failed to locate the second MG (%s).\n", MG_info1->rtp1.ip_string);
	     }
         op_sim_end("MGC ERROR: ",
		            "Failed to locate the second MG!",
		            OPC_NIL,
                    OPC_NIL);
      }

      /* Find the third MG. */
	  bMG3Exist = OPC_FALSE;
      list_size = op_prg_list_size(ptr_MG_list);
      for (i = 0; i < list_size; i++)
      {     
         MG_info3 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
         if (!strcmp(MG_info3->ip_string, MG_info1->rtp2.ip_string))
         {  
            bMG3Exist = OPC_TRUE;
		    break;
         }
      }
   
      if (!bMG3Exist) {
   
	     if (VERBOSE) {
            printf("MGC ERROR: Failed to locate the third MG (%s).\n", MG_info1->rtp2.ip_string);
	     }
         op_sim_end("MGC ERROR: ",
		            "Failed to locate the third MG!",
		            OPC_NIL,
                    OPC_NIL);
      }
	  
	  /* Tell the talking party to be silent. */
	  if ((MG_info1->talking_party == 1) ||
		  ((MG_info1->talking_party == 0) &&
		   (MG_info1->rtp.waiting_party == 1))) {
	  
	     if (MG_info1->talking_party == 1) {
		 
		    if (VERBOSE) {
			   printf("MGC Info: Make MG (%s) to be silent.\n", MG_info1->rtp1.ip_string);
			}
		 
            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
   
            /* Set the MG that will be waiting. */
            MG_info2->rtp.waiting_party = MG_info2->talking_party;
		    MG_info2->talking_party = 0;
   
            /* Set parameters of the Modify message. */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
            modify_param.rtp_exist = 1;
            strcpy(modify_param.rtp_context_id, MG_info1->rtp1.context_id);
            strcpy(modify_param.rtp_termination_id, "tr");
            modify_param.rtp_localcontrol_exist = 1;
            strcpy(modify_param.rtp_localcontrol_mode, "ReceiveOnly");
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
	                         megaco_msg,
				             MG_info2->ip_string,
					         MG_info2->ptr_megaco_req_msg);
		 }

         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
   
         /* Set the AuditValue parameters */
         strcpy(av_param.mgc_ip_address, mgc_ip_string);
         strcpy(av_param.mgc_udp_port, mgc_udp_string);
         sprintf(av_param.transaction_id, "%d", mgc_transaction_id);
         strcpy(av_param.context_id, "-");
         strcpy(av_param.termination_id1, "tr");
   
         /* Send AuditValue message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_auditvalue(&av_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
			              megaco_msg,
						  MG_info1->ip_string,
						  MG_info1->ptr_megaco_req_msg);		 
		 
         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }

   	     /* Set the call-switching MG */
	     (MG_info1->at.signal)[0] = '\0';
	     MG_info1->at.status = 0;
		 
		 if (MG_info3->talking_party != 0) {
		 
		    if (VERBOSE) {
			   printf("MGC Info: The party (%s) I am switching to is talking, so silent.\n",
				      MG_info1->rtp2.ip_string);
			}
		 
		    MG_info1->rtp.waiting_party = 2;
	        MG_info1->talking_party = 0;
			
            /* Set parameters of the Modify message. */
            memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
            strcpy(move_param.mgc_ip_address, mgc_ip_string);
            strcpy(move_param.mgc_udp_port, mgc_udp_string);
            sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
            strcpy(move_param.context_id, MG_info1->rtp2.context_id);
			
            move_param.signal_exist = 1;
            strcpy(move_param.signal_termination_id, "at/hf");
			(move_param.signal)[0] = '\0';
			move_param.rtp_exist = 1;
			strcpy(move_param.rtp_termination_id, "tr");
            move_param.rtp_localcontrol_exist = 1;
            strcpy(move_param.rtp_localcontrol_mode, "ReceiveOnly");
			move_param.rtp_remote_exist = 1;
			strcpy(move_param.rtp_remote_address, MG_info1->rtp2.ip_string);
			strcpy(move_param.rtp_remote_port, MG_info1->rtp2.udp_string);
			strcpy(move_param.rtp_remote_codec, MG_info1->rtp2.codec);
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_move(&move_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info1->ip_string,
 				             MG_info1->ptr_megaco_req_msg);
			
		 } else {
		 
		    if (VERBOSE) {
			   printf("MGC Info: I am switching to party (%s).\n",
				      MG_info1->rtp2.ip_string);
			}
		 
		    MG_info1->talking_party = 2;
			
            /* Set parameters of the Modify message. */
            memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
            strcpy(move_param.mgc_ip_address, mgc_ip_string);
            strcpy(move_param.mgc_udp_port, mgc_udp_string);
            sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
            strcpy(move_param.context_id, MG_info1->rtp2.context_id);
			
            move_param.signal_exist = 1;
            strcpy(move_param.signal_termination_id, "at/hf");
			(move_param.signal)[0] = '\0';
			move_param.rtp_exist = 1;
			strcpy(move_param.rtp_termination_id, "tr");
			move_param.rtp_localcontrol_exist = 1;
			strcpy(move_param.rtp_localcontrol_mode, "SendReceive");
			move_param.rtp_remote_exist = 1;
			strcpy(move_param.rtp_remote_address, MG_info1->rtp2.ip_string);
			strcpy(move_param.rtp_remote_port, MG_info1->rtp2.udp_string);
			strcpy(move_param.rtp_remote_codec, MG_info1->rtp2.codec);
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_move(&move_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info1->ip_string,
 				             MG_info1->ptr_megaco_req_msg);

            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
			
            /* Create a new Request ID. */
            if (mgc_request_id == 999999) {
               mgc_request_id = 1;
            } else {
               mgc_request_id++;
            }
			
			/* Set the MG */
			strcpy(MG_info3->ui.event, "key/ku, key/kf");
			MG_info3->ui.status = mgc_request_id;
			(MG_info3->at.signal)[0] = '\0';
			MG_info3->at.status = 0;
			if (!strcmp(MG_info3->rtp1.ip_string, MG_info1->rtp.ip_string)) {
			   MG_info3->talking_party = 1;
			} else if (!strcmp(MG_info3->rtp2.ip_string, MG_info1->rtp.ip_string)) {
			   MG_info3->talking_party = 2;
			} else {
			
			   if (VERBOSE) {
			      printf("MGC ERROR: Invalid switching operation.\n");
			   }
			   op_sim_end("MGC ERROR: ",
				          "Invalid switching operation!\n",
						  OPC_NIL,
						  OPC_NIL);
			}

            /* Set parameters of the Modify message. */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
			modify_param.event_exist = 1;
            strcpy(modify_param.event_context_id, "-");
            strcpy(modify_param.event_termination_id, "ui");
            sprintf(modify_param.event_request_id, "%d", mgc_request_id);
            strcpy(modify_param.event, "key/ku, key/kf");
            modify_param.signal_exist = 1;
            strcpy(modify_param.signal_context_id, MG_info1->rtp2.context_id);
            strcpy(modify_param.signal_termination_id, "at/hf");
            (modify_param.signal)[0] = '\0';
            modify_param.rtp_exist = 1;
            strcpy(modify_param.rtp_context_id, MG_info1->rtp2.context_id);
            strcpy(modify_param.rtp_termination_id, "tr");
            modify_param.rtp_localcontrol_exist = 1;
            strcpy(modify_param.rtp_localcontrol_mode, "SendReceive");
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
	                         megaco_msg,
		     		         MG_info1->rtp2.ip_string,
			                 MG_info3->ptr_megaco_req_msg);

		 }
	  
	  } else if ((MG_info1->talking_party == 2) ||
		         ((MG_info1->talking_party == 0) &&
				  (MG_info1->rtp.waiting_party == 2))){
	  
	     if (MG_info1->talking_party == 2) {
		 
		    if (VERBOSE) {
			   printf("MGC Info: Make MG (%s) to be silent.\n", MG_info1->rtp2.ip_string);
			}
		 
            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
   
		    /* Set the MG that will be waiting. */
		    MG_info3->rtp.waiting_party = MG_info3->talking_party;
		    MG_info3->talking_party = 0;
   
            /* Set parameters of the Modify message. */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
            modify_param.rtp_exist = 1;
            strcpy(modify_param.rtp_context_id, MG_info1->rtp2.context_id);
            strcpy(modify_param.rtp_termination_id, "tr");
            modify_param.rtp_localcontrol_exist = 1;
            strcpy(modify_param.rtp_localcontrol_mode, "ReceiveOnly");
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
	                         megaco_msg,
				             MG_info3->ip_string,
					         MG_info3->ptr_megaco_req_msg);
		 }

         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
   
         /* Set the AuditValue parameters */
         strcpy(av_param.mgc_ip_address, mgc_ip_string);
         strcpy(av_param.mgc_udp_port, mgc_udp_string);
         sprintf(av_param.transaction_id, "%d", mgc_transaction_id);
         strcpy(av_param.context_id, "-");
         strcpy(av_param.termination_id1, "tr");
   
         /* Send AuditValue message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_auditvalue(&av_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
			              megaco_msg,
						  MG_info1->ip_string,
						  MG_info1->ptr_megaco_req_msg);		 
		 
         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }

   	     /* Set the call-switching MG */
	     (MG_info1->at.signal)[0] = '\0';
	     MG_info1->at.status = 0;
		 
		 if (MG_info2->talking_party != 0) {
		 
		    if (VERBOSE) {
			   printf("MGC Info: The party (%s) I am switching to is talking, so silent.\n",
				      MG_info1->rtp1.ip_string);
			}
		 
		    MG_info1->rtp.waiting_party = 1;
	        MG_info1->talking_party = 0;
			
            /* Set parameters of the Modify message. */
            memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
            strcpy(move_param.mgc_ip_address, mgc_ip_string);
            strcpy(move_param.mgc_udp_port, mgc_udp_string);
            sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
            strcpy(move_param.context_id, MG_info1->rtp1.context_id);
			
            move_param.signal_exist = 1;
            strcpy(move_param.signal_termination_id, "at/hf");
			(move_param.signal)[0] = '\0';
			move_param.rtp_exist = 1;
			strcpy(move_param.rtp_termination_id, "tr");
            move_param.rtp_localcontrol_exist = 1;
            strcpy(move_param.rtp_localcontrol_mode, "ReceiveOnly");
			move_param.rtp_remote_exist = 1;
			strcpy(move_param.rtp_remote_address, MG_info1->rtp1.ip_string);
			strcpy(move_param.rtp_remote_port, MG_info1->rtp1.udp_string);
			strcpy(move_param.rtp_remote_codec, MG_info1->rtp1.codec);
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_move(&move_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info1->ip_string,
 				             MG_info1->ptr_megaco_req_msg);
			
		 } else {
		 
		    if (VERBOSE) {
			   printf("MGC Info: I am switching to party (%s).\n",
				      MG_info1->rtp1.ip_string);
			}
		 
		    MG_info1->talking_party = 1;
			
            /* Set parameters of the Modify message. */
            memset(&move_param, 0, sizeof(STRUCT_MEGACO_MOVE_PARAM));
            strcpy(move_param.mgc_ip_address, mgc_ip_string);
            strcpy(move_param.mgc_udp_port, mgc_udp_string);
            sprintf(move_param.transaction_id, "%d", mgc_transaction_id);
            strcpy(move_param.context_id, MG_info1->rtp1.context_id);
			
            move_param.signal_exist = 1;
            strcpy(move_param.signal_termination_id, "at/hf");
			(move_param.signal)[0] = '\0';
			move_param.rtp_exist = 1;
			strcpy(move_param.rtp_termination_id, "tr");
			move_param.rtp_localcontrol_exist = 1;
			strcpy(move_param.rtp_localcontrol_mode, "SendReceive");
			move_param.rtp_remote_exist = 1;
			strcpy(move_param.rtp_remote_address, MG_info1->rtp1.ip_string);
			strcpy(move_param.rtp_remote_port, MG_info1->rtp1.udp_string);
			strcpy(move_param.rtp_remote_codec, MG_info1->rtp1.codec);
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_move(&move_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
                             megaco_msg,
 			                 MG_info1->ip_string,
 				             MG_info1->ptr_megaco_req_msg);

            /* Create a new Transaction ID. */
            if (mgc_transaction_id == 999999) {
               mgc_transaction_id = 1;
            } else {
               mgc_transaction_id++;
            }
			
            /* Create a new Request ID. */
            if (mgc_request_id == 999999) {
               mgc_request_id = 1;
            } else {
               mgc_request_id++;
            }
			
			/* Set the MG */
			strcpy(MG_info2->ui.event, "key/ku, key/kf");
			MG_info2->ui.status = mgc_request_id;
			(MG_info2->at.signal)[0] = '\0';
			MG_info2->at.status = 0;
			if (!strcmp(MG_info2->rtp1.ip_string, MG_info1->rtp.ip_string)) {
			   MG_info2->talking_party = 1;
			} else if (!strcmp(MG_info2->rtp2.ip_string, MG_info1->rtp.ip_string)) {
			   MG_info2->talking_party = 2;
			} else {
			
			   if (VERBOSE) {
			      printf("MGC ERROR: Invalid switching operation.\n");
			   }
			   op_sim_end("MGC ERROR: ",
				          "Invalid switching operation!\n",
						  OPC_NIL,
						  OPC_NIL);
			}

            /* Set parameters of the Modify message. */
            memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
            strcpy(modify_param.mgc_ip_address, mgc_ip_string);
            strcpy(modify_param.mgc_udp_port, mgc_udp_string);
            sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
			modify_param.event_exist = 1;
            strcpy(modify_param.event_context_id, "-");
            strcpy(modify_param.event_termination_id, "ui");
            sprintf(modify_param.event_request_id, "%d", mgc_request_id);
            strcpy(modify_param.event, "key/ku, key/kf");
            modify_param.signal_exist = 1;
            strcpy(modify_param.signal_context_id, MG_info1->rtp1.context_id);
            strcpy(modify_param.signal_termination_id, "at/hf");
            (modify_param.signal)[0] = '\0';
            modify_param.rtp_exist = 1;
            strcpy(modify_param.rtp_context_id, MG_info1->rtp1.context_id);
            strcpy(modify_param.rtp_termination_id, "tr");
            modify_param.rtp_localcontrol_exist = 1;
            strcpy(modify_param.rtp_localcontrol_mode, "SendReceive");
		 
            /* Send Modify message to message queue. */
            memset(megaco_msg, 0, MAX_MSG_SIZE);
            compose_modify(&modify_param, megaco_msg);
            add_msg_to_queue(mgc_transaction_id,
	                         megaco_msg,
		     		         MG_info1->rtp1.ip_string,
			                 MG_info2->ptr_megaco_req_msg);
		 }

	  } else {
	  
	     if (VERBOSE) {
		    printf("MGC ERROR: Failed to determine which party (%s or %s) to switch to.\n",
				   MG_info1->rtp1.ip_string,
				   MG_info1->rtp2.ip_string);
		 }
		 op_sim_end("MGC ERROR: ",
			        "Failed to determine which party to switch to!",
					OPC_NIL,
					OPC_NIL);
	  }
   }
   else
   {
      if (VERBOSE) {
	     printf("MGC ERROR: Invalid event (%s).\n", parameters->detection_event);
	  }
      op_sim_end("MGC ERROR: ",
		         "Failed to determine the event!",
				 OPC_NIL,
				 OPC_NIL);
   }

   if (VERBOSE) {
      printf("MGC: Out notify_process().\n");
   }
   
   FOUT;
}

/* --------------------------------------------------------------------------------- 
 *  Process Modify Reply
 * --------------------------------------------------------------------------------*/         
void modify_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMGExist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info;
   
   FIN(modify_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into modify_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Modify parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMGExist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out modify_process().\n");
   }
   
   FOUT;
}


/* --------------------------------------------------------------------------------- 
 *  Process Move Reply
 * --------------------------------------------------------------------------------*/         
void move_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMGExist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info;
   
   FIN(move_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into move_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Move parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMGExist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out move_process().\n");
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Process Add Reply
 *  Note: 
 *  There are 3 types of Add Reply messages:
 *  [1] First Add Reply for Regular Call
 *  [2] Second Add Reply for Regular Call
 *  [3] Add Reply for Call Waiting
 * ---------------------------------------------*/
void add_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMG1Exist = OPC_FALSE;
   Boolean          bMG2Exist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info1;
   STRUCT_MEGACO_MG *MG_info2;
   
   char             megaco_msg[MAX_MSG_SIZE];
   STRUCT_MEGACO_ADD_PARAM add_param;
   STRUCT_MEGACO_MODIFY_PARAM modify_param;
   
   
   FIN(add_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into add_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid ||
	   !parameters->termination_id2_valid ||
	   !parameters->audio_ip_address_valid ||
	   !parameters->audio_udp_port_valid ||
	   !parameters->codec_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Add parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMG1Exist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info1 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info1->ip_string, parameters->mg_ip_address))
	  {  
         bMG1Exist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMG1Exist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }

   } else if (strlen(MG_info1->rtp1.ip_string) > 0) {
   
      /* Find the other MG. */
      bMG2Exist = OPC_FALSE;
      list_size = op_prg_list_size(ptr_MG_list);
      for (i = 0; i < list_size; i++)
      {     
         MG_info2 = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
         if (!strcmp(MG_info2->ip_string, MG_info1->rtp1.ip_string))
	     {  
            bMG2Exist = OPC_TRUE;
            break;
         }
      }
   
      if (!bMG2Exist) {
   
         if (VERBOSE) {
	        printf("MGC ERROR: Failed to locate the other MG (%s).\n", MG_info1->rtp1.ip_string);
	     }
         op_sim_end("MGC ERROR: ",
		            "Failed to locate the other MG!",
			        OPC_NIL,
                    OPC_NIL);
	  }
	  
	  if ((MG_info1->rtp.status == 0) &&
		  (MG_info1->rtp1.status == 0) &&
		  (MG_info1->rtp2.status == 0) &&
		  (MG_info2->rtp.status == 0) &&
		  (MG_info2->rtp1.status == 0) &&
		  (MG_info2->rtp2.status == 0)) {
	  
	     /* Regular call - first add reply */
	     if (VERBOSE) {
		    printf("MGC Info: Reach first Add Reply message.\n");
		 }
	  
	     /* Set up the state of the MGs */
	     strcpy(MG_info1->rtp.ip_string, parameters->audio_ip_address);
		 strcpy(MG_info1->rtp.udp_string, parameters->audio_udp_port);
		 strcpy(MG_info1->rtp.codec, parameters->codec);
		 MG_info1->rtp.status = 1;
	  
		 strcpy(MG_info2->rtp1.ip_string, parameters->audio_ip_address);
		 strcpy(MG_info2->rtp1.udp_string, parameters->audio_udp_port);
		 strcpy(MG_info2->rtp1.codec, parameters->codec);
		 strcpy(MG_info2->rtp1.context_id, MG_info1->rtp1.context_id);
		 MG_info2->rtp1.status = 1;
		 
		 strcpy(MG_info2->at.signal, "cg/rt");
		 MG_info2->at.status = 1;

         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
				
		 /* Need to send another Add Request to the second MG */
         memset(&add_param, 0, sizeof(STRUCT_MEGACO_ADD_PARAM));
         strcpy(add_param.mgc_ip_address, mgc_ip_string);
         strcpy(add_param.mgc_udp_port, mgc_udp_string);
         sprintf(add_param.transaction_id, "%d", mgc_transaction_id);
	     strcpy(add_param.context_id, MG_info1->rtp1.context_id);
         add_param.signal_exist = 1;
         strcpy(add_param.signal_termination_id, "at/hf");
         strcpy(add_param.signal, "cg/rt");
	     add_param.rtp_exist = 1;
	     strcpy(add_param.rtp_termination_id, "tr");
	     add_param.rtp_localcontrol_exist = 1;
	     strcpy(add_param.rtp_localcontrol_mode, "SendReceive");
	     add_param.rtp_local1_exist = 1;
		 add_param.rtp_remote_exist = 1;
         strcpy(add_param.rtp_remote_address, parameters->audio_ip_address);
         strcpy(add_param.rtp_remote_port, parameters->audio_udp_port);
         strcpy(add_param.rtp_remote_codec, parameters->codec);
   
         /* Send Add message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_add(&add_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
		                  megaco_msg,
			   		      MG_info2->ip_string,
		                  MG_info2->ptr_megaco_req_msg);
	  
	  } else if ((MG_info1->rtp.status == 0) &&
		         (MG_info1->rtp1.status == 1) &&
				 (MG_info1->rtp2.status == 0) &&
				 (MG_info2->rtp.status == 1) &&
				 (MG_info2->rtp1.status == 0) &&
				 (MG_info2->rtp2.status == 0)) {
	  
	     /* Regular call - second add reply */
 	     if (VERBOSE) {
		    printf("MGC Info: Reach Second Add Reply message.\n");
		 }
	  
	     /* Set up the state of the MGs */
	     strcpy(MG_info1->rtp.ip_string, parameters->audio_ip_address);
		 strcpy(MG_info1->rtp.udp_string, parameters->audio_udp_port);
		 strcpy(MG_info1->rtp.codec, parameters->codec);
		 MG_info1->rtp.status = 1;
	  
		 strcpy(MG_info2->rtp1.ip_string, parameters->audio_ip_address);
		 strcpy(MG_info2->rtp1.udp_string, parameters->audio_udp_port);
		 strcpy(MG_info2->rtp1.codec, parameters->codec);
		 strcpy(MG_info2->rtp1.context_id, MG_info1->rtp1.context_id);
		 MG_info2->rtp1.status = 1;
		 
		 strcpy(MG_info2->at.signal, "cg/rt");
		 MG_info2->at.status = 1;

         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }
		 
		 /* Need to send the Modify Request to the first MG */
         memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
         strcpy(modify_param.mgc_ip_address, mgc_ip_string);
         strcpy(modify_param.mgc_udp_port, mgc_udp_string);
         sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
         modify_param.signal_exist = 1;
         strcpy(modify_param.signal_context_id, MG_info1->rtp1.context_id);
         strcpy(modify_param.signal_termination_id, "at/hf");
         strcpy(modify_param.signal, "cg/rt");
         modify_param.rtp_exist = 1;
         strcpy(modify_param.rtp_context_id, MG_info1->rtp1.context_id);
         strcpy(modify_param.rtp_termination_id, "tr");
         modify_param.rtp_remote_exist = 1;
         strcpy(modify_param.rtp_remote_address, parameters->audio_ip_address);
         strcpy(modify_param.rtp_remote_port, parameters->audio_udp_port);
         strcpy(modify_param.rtp_remote_codec, parameters->codec);
   
         /* Send Modify message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_modify(&modify_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
                          megaco_msg,
						  MG_info2->ip_string,
				          MG_info2->ptr_megaco_req_msg);
	  
	  } else if ((MG_info1->rtp.status == 0) &&
		         (MG_info1->rtp1.status == 1) &&
				 (MG_info1->rtp2.status == 0) &&
				 (MG_info2->rtp.status == 1) &&
				 (((MG_info2->rtp1.status == 1) &&
				   (MG_info2->rtp2.status == 0)) ||
		          ((MG_info2->rtp1.status == 0) &&
				   (MG_info2->rtp2.status == 1)))) {
	  
         /* Calling waiting */
	  
	     /* Set up the state of the MGs */
	     strcpy(MG_info1->rtp.ip_string, parameters->audio_ip_address);
		 strcpy(MG_info1->rtp.udp_string, parameters->audio_udp_port);
		 strcpy(MG_info1->rtp.codec, parameters->codec);
		 MG_info1->rtp.status = 1;
	  
		 if (MG_info2->rtp1.status == 0) {
		 
            strcpy(MG_info2->rtp1.ip_string, parameters->audio_ip_address);
		    strcpy(MG_info2->rtp1.udp_string, parameters->audio_udp_port);
		    strcpy(MG_info2->rtp1.codec, parameters->codec);
		    strcpy(MG_info2->rtp1.context_id, MG_info1->rtp1.context_id);
		    MG_info2->rtp1.status = 1;

		 } else {
		 
		    strcpy(MG_info2->rtp2.ip_string, parameters->audio_ip_address);
		    strcpy(MG_info2->rtp2.udp_string, parameters->audio_udp_port);
		    strcpy(MG_info2->rtp2.codec, parameters->codec);
		    strcpy(MG_info2->rtp2.context_id, MG_info1->rtp1.context_id);
		    MG_info2->rtp2.status = 1;
		 }
		 
		 strcpy(MG_info1->at.signal, "cg/rt");
		 MG_info1->at.status = 1;
		 strcpy(MG_info2->at.signal, "cg/rt");
		 MG_info2->at.status = 1;
		 
         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }

		 /* Need to send the talking party a Modify request. */
         memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
         strcpy(modify_param.mgc_ip_address, mgc_ip_string);
         strcpy(modify_param.mgc_udp_port, mgc_udp_string);
         sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
         modify_param.signal_exist = 1;
         strcpy(modify_param.signal_context_id, MG_info1->rtp1.context_id);
         strcpy(modify_param.signal_termination_id, "at/hf");
         strcpy(modify_param.signal, "cg/rt");
   
         /* Send Modify message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_modify(&modify_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
                          megaco_msg,
						  MG_info2->ip_string,
				          MG_info2->ptr_megaco_req_msg);

         /* Create a new Transaction ID. */
         if (mgc_transaction_id == 999999) {
            mgc_transaction_id = 1;
         } else {
            mgc_transaction_id++;
         }

		 /* Need to send the calling party a Modify request. */
         memset(&modify_param, 0, sizeof(STRUCT_MEGACO_MODIFY_PARAM));
         strcpy(modify_param.mgc_ip_address, mgc_ip_string);
         strcpy(modify_param.mgc_udp_port, mgc_udp_string);
         sprintf(modify_param.transaction_id, "%d", mgc_transaction_id);
         modify_param.signal_exist = 1;
         strcpy(modify_param.signal_context_id, MG_info1->rtp1.context_id);
         strcpy(modify_param.signal_termination_id, "at/hf");
         strcpy(modify_param.signal, "cg/rt");
         modify_param.rtp_exist = 1;
         strcpy(modify_param.rtp_context_id, MG_info1->rtp1.context_id);
         strcpy(modify_param.rtp_termination_id, "tr");
         modify_param.rtp_remote_exist = 1;
         strcpy(modify_param.rtp_remote_address, MG_info1->rtp1.ip_string);
         strcpy(modify_param.rtp_remote_port, MG_info1->rtp1.udp_string);
         strcpy(modify_param.rtp_remote_codec, MG_info1->rtp1.codec);
   
         /* Send Modify message to MG. */
         memset(megaco_msg, 0, MAX_MSG_SIZE);
         compose_modify(&modify_param, megaco_msg);
         add_msg_to_queue(mgc_transaction_id,
                          megaco_msg,
						  MG_info1->ip_string,
				          MG_info1->ptr_megaco_req_msg);
		 
	  } else {
	  
         if (VERBOSE) {
	        printf("MGC ERROR: Failed to determine the call scenario of the MG (%s).\n",
				   MG_info1->rtp1.ip_string);
	     }
         op_sim_end("MGC ERROR: ",
		            "Failed to determine the call scenario of the MG!",
			        OPC_NIL,
                    OPC_NIL);
	  }
   
   } else {
   
      if (VERBOSE) {
	     printf("MGC ERROR: The RTP1 IP address of MG (%s) is not found.\n", MG_info1->ip_string);
	  }
	  op_sim_end("MGC ERROR: ",
	             "Failed to find the IP address of the other party!",
		         OPC_NIL,
				 OPC_NIL);
   }
   
   if (VERBOSE) {
      printf("MGC: Out add_process().\n");
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Process Subtract Reply
 * ---------------------------------------------*/
void subtract_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMGExist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info;
   
   FIN(subtract_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into subtract_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid ||
	   !parameters->termination_id2_valid ||
	   !parameters->rtp_ps_valid ||
	   !parameters->rtp_pr_valid ||
	   !parameters->rtp_pl_valid ||
	   !parameters->rtp_jit_valid ||
	   !parameters->rtp_delay_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve Subtract parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMGExist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out subtract_process().\n");
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Process AuditValue Reply
 * ---------------------------------------------*/
void auditvalue_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMGExist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info;
   
   FIN(auditvalue_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into auditvalue_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve AuditValue parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMGExist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out auditvalue_process().\n");
   }
   
   FOUT;
}

/* ---------------------------------------------- 
 *  Process AuditCapability Reply
 * ---------------------------------------------*/
void auditcapability_process(STRUCT_MEGACO_MSG_PARAM *parameters)
{
   int              i, list_size;
   Boolean          bMGExist = OPC_FALSE;
   STRUCT_MEGACO_MG *MG_info;
   
   FIN(auditcapability_process(parameters));
   
   if (VERBOSE) {
      printf ("MGC: Into auditcapability_process().\n");
   }
   
   /* Check if the megaco message parameters are valid or not */
   if (!parameters->mg_ip_address_valid ||
	   !parameters->mg_udp_port_valid ||
	   !parameters->transaction_id_valid ||
	   !parameters->context_id_valid ||
	   !parameters->termination_id1_valid) {
	  
	  op_sim_end("MGC ERROR: ",
		         "Failed to retrieve AuditCapability parameters!",
				 OPC_NIL,
				 OPC_NIL);
   }
   
   /* Find the specified MG. */
   bMGExist = OPC_FALSE;
   list_size = op_prg_list_size(ptr_MG_list);
   for (i = 0; i < list_size; i++)
   {     
      MG_info = (STRUCT_MEGACO_MG *) op_prg_list_access(ptr_MG_list, i);
      if (!strcmp(MG_info->ip_string, parameters->mg_ip_address))
	  {  
         bMGExist = OPC_TRUE;
		 break;
	  }
   }
   
   if (!bMGExist) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to locate MG (%s).\n", parameters->mg_ip_address);
	  }
	  op_sim_end("MGC ERROR: ",
		         "Failed to locate the MG!",
				 OPC_NIL,
				 OPC_NIL);

   } else if (!remove_msg_from_queue(atoi(parameters->transaction_id))) {
   
      if (VERBOSE) {
	     printf("MGC ERROR: Failed to remove the message block.\n");
		 printf("MGC ERROR: Transaction ID of the message block - %s\n", parameters->transaction_id);
	  }
   }
   
   if (VERBOSE) {
      printf("MGC: Out auditcapability_process().\n");
   }
   
   FOUT;
}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void megaco_mgc_node (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_megaco_mgc_node_init (int * init_block_ptr);
	void _op_megaco_mgc_node_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_megaco_mgc_node_terminate (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Address _op_megaco_mgc_node_alloc (VosT_Obtype, int);
	void _op_megaco_mgc_node_svar (void *, const char *, void **);


#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
megaco_mgc_node (OP_SIM_CONTEXT_ARG_OPT)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (megaco_mgc_node ());

		{
		/* Temporary Variables */
		/* To handle incoming packet */
		Packet *megaco_pkt;
		Packet *ptr_megaco_pkt;
		STRUCT_MEGACO_MSG *ptr_megaco_msg;
		
		/* To manipulate the message queue */
		STRUCT_MSG_QUEUE_BLK *msg_queue_blk;
		
		int command_type;
		
		Boolean need_to_send;
		/* End of Temporary Variables */


		FSM_ENTER ("megaco_mgc_node")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "megaco_mgc_node [init enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mgc_node [init enter execs]", state0_enter_exec)
				{
				/*  Initialization. */
				if (op_ima_sim_attr_exists ("MGC debug information") == OPC_TRUE)
				{
				   /* The simulation attribute has been specified a value.	*/
				   op_ima_sim_attr_get (OPC_IMA_INTEGER, "MGC debug information", &VERBOSE);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MGC IP Address") == OPC_TRUE) {
				   op_ima_obj_attr_get(op_id_self(), "MGC IP Address", mgc_ip_string);
				   if (VERBOSE) {
				      printf("MGC: IP Address found - %s\n", mgc_ip_string);
				   }
				} else {
				   op_sim_end("MGC ERROR: ", "Failed to obtain the MGC IP Address!", OPC_NIL, OPC_NIL);
				}
				
				if (op_ima_obj_attr_exists(op_id_self(), "MGC UDP Port") == OPC_TRUE) {
				   op_ima_obj_attr_get(op_id_self(), "MGC UDP Port", mgc_udp_string);
				   if (VERBOSE) {
				      printf("MGC UDP Port found - %s\n", mgc_udp_string);
				   }
				} else {
				   op_sim_end("MGC ERROR: ", "Failed to obtain the MGC UDP Port!", OPC_NIL, OPC_NIL);
				}
				
				if (VERBOSE) {
				   printf("\n\n");
				   printf("[Component] MGC\n");
				   printf("[Place] FSM->init->Enter\n");
				   printf("[Info] Initialization\n");
				}
				
				strncpy(line_feed, "\n", 2);
				
				msg_no = 1;
				mgc_transaction_id = 0;
				mgc_request_id = 0;
				mgc_context_id = 0;
				
				
				ptr_outstanding_message_list = op_prg_list_create();
				if (ptr_outstanding_message_list == OPC_NIL) {
				
				   op_sim_end("MGC ERROR: ",
					          "Failed to create message queue!",
							  OPC_NIL,
							  OPC_NIL);
				}
				
				ptr_MG_list = op_prg_list_create();
				if (ptr_MG_list == OPC_NIL) {
				
				   op_sim_end("MGC ERROR: ",
					          "Failed to create MG list!",
							  OPC_NIL,
							  OPC_NIL);
				}
				
				ptr_megaco_msg_param = (STRUCT_MEGACO_MSG_PARAM *)op_prg_mem_alloc(sizeof(STRUCT_MEGACO_MSG_PARAM));
				if (ptr_megaco_msg_param == OPC_NIL) {
				
				   op_sim_end("MGC ERROR: ",
					          "Failed to allocate memory for the Megaco message parameters!",
							  OPC_NIL,
							  OPC_NIL);
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "megaco_mgc_node [init exit execs]")


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle", "tr_1", "megaco_mgc_node [init -> idle : default / ]")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "idle", state1_enter_exec, "megaco_mgc_node [idle enter execs]")

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"megaco_mgc_node")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "megaco_mgc_node [idle exit execs]")


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("megaco_mgc_node [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (MSG_ARVL)
			FSM_TEST_COND (SEND_CHECK)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "MSG_ARVL", "", "idle", "process", "tr_3", "megaco_mgc_node [idle -> process : MSG_ARVL / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "SEND_CHECK", "", "idle", "send", "tr_9", "megaco_mgc_node [idle -> send : SEND_CHECK / ]")
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;, "default", "", "idle", "idle", "tr_2", "megaco_mgc_node [idle -> idle : default / ]")
				}
				/*---------------------------------------------------------*/



			/** state (process) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "process", state2_enter_exec, "megaco_mgc_node [process enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mgc_node [process enter execs]", state2_enter_exec)
				{
				/* -----------------------------------------
				 *  Get theptr_megaco_pkt handle to the incoming packet.
				 * ----------------------------------------*/
				
				if (VERBOSE)  {
				   printf("\n\n");
				   printf("[Component] MGC\n");
				   printf("[Place] FSM->process->Enter\n");
				   printf("[Info] Getting packet\n");
				}
				
				megaco_pkt = op_pk_get(op_intrpt_strm());
				
				/* Get the data from the incoming packet */
				op_pk_nfd_get(megaco_pkt, "data", &ptr_megaco_pkt);
				op_pk_destroy(megaco_pkt);
				
				if (VERBOSE) {
				   printf("\n\n");
				   printf("[Component] MGC\n");
				   printf("[Place] FSM->process->Enter\n");
				   printf("[Info] Found Packet\n");
				}
				
				
				/* -----------------------------------------
				2)   Get the megaco msg. 
				--------------------------------------------*/
				
				if (VERBOSE) {
				   printf("\n\n");
				   printf("[Component] MGC\n");
				   printf("[Place] FSM->process->Enter\n");
				   printf("[Info] Obtaining Megaco message\n");
				}
				
				op_pk_fd_get(ptr_megaco_pkt, 0, &ptr_megaco_msg);
				op_pk_destroy(ptr_megaco_pkt);
				
				if (VERBOSE)
				{
				   if (ptr_megaco_msg->msg == OPC_NIL) {
				      printf("\n\n");
				      printf("[Component] MGC\n");
					  printf("[Place] FSM->process->Enter\n");
					  printf("[Info] Message is NULL!\n");
				   } else {
				      printf("\n\n");
				      printf("[Component] MGC\n");
					  printf("[Place] FSM->process->Enter\n");
					  printf("[Info] Message got:\n");
					  printf("%s\n", ptr_megaco_msg->msg);
					  printf("***End***\n");
				   }
				}
				
				if (ptr_megaco_msg->msg == OPC_NIL)
				{
				   op_sim_end("Error in MGC Module process model: ", 
						      "There is no message!", 
						      OPC_NIL,
							  OPC_NIL);
				}
				
				
				/* -----------------------------------------
				3)   Parse the megaco msg. 
				--------------------------------------------*/
				command_type = parse_megaco_msg(ptr_megaco_msg_param, ptr_megaco_msg);
				
				switch (command_type)
				{
				   case MEGACO_MSG_SERVICECHANGE:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into servicechange_process().\n");
					  }
				      servicechange_process(ptr_megaco_msg_param);
				      break;
				
				   case MEGACO_MSG_NOTIFY:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into notify_process().\n");
					  }
					  notify_process(ptr_megaco_msg_param);   
				      break;
				
				   case MEGACO_MSG_MODIFY:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into modify_process().\n");
					  }
				      modify_process(ptr_megaco_msg_param);   
				      break;
					  
				   case MEGACO_MSG_MOVE:
				   
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into move_process().\n");
					  }
				      move_process(ptr_megaco_msg_param);
					  break;
				
				   case MEGACO_MSG_ADD:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into add_process().\n");
					  }
				      add_process(ptr_megaco_msg_param);   
				      break;
				
				   case MEGACO_MSG_SUBTRACT:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into subtract_process().\n");
					  }
				      subtract_process(ptr_megaco_msg_param);   
				      break;
					  
				   case MEGACO_MSG_AUDITVALUE:
				   
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into auditvalue_process().\n");
					  }
					  auditvalue_process(ptr_megaco_msg_param);
					  break;
					  
				   case MEGACO_MSG_AUDITCAPABILITY:
				   
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Before into auditcapability_process().\n");
					  }
				      auditcapability_process(ptr_megaco_msg_param);
					  break;
				
				   default:
				
				      if (VERBOSE) {
					     printf("\n\n");
				         printf("[Component] MGC\n");
						 printf("[Place] FSM->process->Enter\n");
						 printf("[Info] Failed to determine the command type!\n");
					  }
					  
				      op_sim_end("Error in MGC Module process model: ",
						         "Failed to determine the command type!",
								 OPC_NIL,
								 OPC_NIL);
					  break;
				}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (process) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "process", "megaco_mgc_node [process exit execs]")


			/** state (process) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "process", "idle", "tr_0", "megaco_mgc_node [process -> idle : default / ]")
				/*---------------------------------------------------------*/



			/** state (send) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "send", state3_enter_exec, "megaco_mgc_node [send enter execs]")
				FSM_PROFILE_SECTION_IN ("megaco_mgc_node [send enter execs]", state3_enter_exec)
				{
				/* -----------------------------------------
				 *  Check if any packet needs to be sent
				 * ----------------------------------------*/
				
				if (ptr_outstanding_message_list == OPC_NIL) {
				   
				   op_sim_end("MGC ERROR: ",
				              "Memory queue is invalid!",
				              OPC_NIL,
				              OPC_NIL);
				}
				
				/* Get the first block in the queue */
				need_to_send = OPC_FALSE;
				
				if (op_prg_list_size(ptr_outstanding_message_list) > 0) {
				
				   msg_queue_blk = (STRUCT_MSG_QUEUE_BLK *) op_prg_list_access(ptr_outstanding_message_list, OPC_LISTPOS_HEAD);
				   if (msg_queue_blk != OPC_NIL) {
				
				      if (msg_queue_blk->sent == 0) {
				
				         /* New Message */
				         msg_queue_blk->sent = 1;
				         msg_queue_blk->num_wait = 0;
				         need_to_send = OPC_TRUE;
				
				      } else if (msg_queue_blk->sent == 1) {
				
				         /* Message has been sent, so waiting for reply */
				         msg_queue_blk->num_wait += 1;
				   
				         if (msg_queue_blk->num_wait >= 5) {
				   
				            msg_queue_blk->num_wait = 0;
				            need_to_send = OPC_FALSE;
				         }
				      }
				   }
				}
				
				
				/* Make a copy and send the packet now */
				if (need_to_send) {
				
				   send_to_MG(msg_queue_blk->megaco_msg, msg_queue_blk->dest_ip_address, msg_queue_blk->ptr_msg_struct);
				   
				   if (VERBOSE) {
				      printf("\n\n");
				      printf("[Component] MGC\n");
				      printf("[Place] FSM->send->Exit\n");
				      printf("[Info] Packet (TransactionID: %d) sent.\n", msg_queue_blk->transaction_id);
				   }
				}
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (send) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "send", "megaco_mgc_node [send exit execs]")


			/** state (send) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "send", "idle", "tr_8", "megaco_mgc_node [send -> idle : default / ]")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"megaco_mgc_node")
		}
	}




void
_op_megaco_mgc_node_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
_op_megaco_mgc_node_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (_op_megaco_mgc_node_terminate ())

	if (1)
		{
		/* Temporary Variables */
		/* To handle incoming packet */
		Packet *megaco_pkt;
		Packet *ptr_megaco_pkt;
		STRUCT_MEGACO_MSG *ptr_megaco_msg;
		
		/* To manipulate the message queue */
		STRUCT_MSG_QUEUE_BLK *msg_queue_blk;
		
		int command_type;
		
		Boolean need_to_send;
		/* End of Temporary Variables */

		/* Termination Block */

		BINIT
		{
		//op_prg_list_free (ptr_outstanding_transaction_list);
		//op_prg_list_free (ptr_outstanding_request_list);
		//op_prg_mem_free (ptr_outstanding_transaction_list);
		//op_prg_mem_free (ptr_outstanding_request_list);
		}

		/* End of Termination Block */

		}
	Vos_Poolmem_Dealloc (op_sv_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in _op_megaco_mgc_node_svar function. */
#undef mgc_ip_string
#undef mgc_udp_string
#undef mgc_transaction_id
#undef mgc_request_id
#undef mgc_context_id
#undef msg_no
#undef ptr_megaco_msg_param
#undef line_feed
#undef ptr_MG_list
#undef ptr_outstanding_message_list

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_megaco_mgc_node_init (int * init_block_ptr)
	{
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_megaco_mgc_node_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (megaco_mgc_node)",
		sizeof (megaco_mgc_node_state));
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
_op_megaco_mgc_node_alloc (VosT_Obtype obtype, int init_block)
	{
#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	megaco_mgc_node_state * ptr;
	FIN_MT (_op_megaco_mgc_node_alloc (obtype))

	ptr = (megaco_mgc_node_state *)Vos_Alloc_Object (obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "megaco_mgc_node [init enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_megaco_mgc_node_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	megaco_mgc_node_state		*prs_ptr;

	FIN_MT (_op_megaco_mgc_node_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (megaco_mgc_node_state *)gen_ptr;

	if (strcmp ("mgc_ip_string" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->mgc_ip_string);
		FOUT
		}
	if (strcmp ("mgc_udp_string" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->mgc_udp_string);
		FOUT
		}
	if (strcmp ("mgc_transaction_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->mgc_transaction_id);
		FOUT
		}
	if (strcmp ("mgc_request_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->mgc_request_id);
		FOUT
		}
	if (strcmp ("mgc_context_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->mgc_context_id);
		FOUT
		}
	if (strcmp ("msg_no" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->msg_no);
		FOUT
		}
	if (strcmp ("ptr_megaco_msg_param" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ptr_megaco_msg_param);
		FOUT
		}
	if (strcmp ("line_feed" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->line_feed);
		FOUT
		}
	if (strcmp ("ptr_MG_list" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ptr_MG_list);
		FOUT
		}
	if (strcmp ("ptr_outstanding_message_list" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ptr_outstanding_message_list);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

